// ==UserScript==
// @name         pixiv图片批量下载器_download_pixiv_img
// @namespace    http://www.saber.xn--6qq986b3xl/?p=2664
// @version      1.9.2
// @description  在多种情景下批量下载pixiv图片
// @author       雪见仙尊
// @include      *://www.pixiv.net/*
// @grant        none
// @run-at document-end
// ==/UserScript==

/*
 *@作者：雪见仙尊
 *@博客：http://www.saber.xn--6qq986b3xl/
 *@转载重用请保留此信息
 *@QQ群：562729095
 */

! function() {
	if (window.location.href.indexOf("whitecube") > 0) {
		alert("本脚本不能在新版pixiv上执行，抱歉~");
		return false;
	}
}()

var _phpPatch = "http://127.0.0.1/getpixivimg.php"; //getpixivimg.php的路径
var crossP_Path = "http://saber.xn--6qq986b3xl/demo/crossP.php"; //crossP.php的路径。无需修改。
var _thisVer = "1.9.0";

var _allmanga = [];
var ajax1Bingfa = 5; //抓取页面（而非下载图片）时的并发数
var ajax1Jiange = 200; //抓取页面的并发请求每个间隔多少毫秒
var ajax1No = 0; //统计有几个并发线程完成所有请求
var startUrl = window.location.href.replace(/&/g, "_and_");

var doc1_jq;
var tagArray = [];

function addTagToArray() {
	var nowAllTag = doc1_jq.find("a.text");
	var nowAllTagText = [];
	for (var i = 0; i < nowAllTag.length; i++) {
		nowAllTagText.push(nowAllTag.eq(i).text());
	}
	tagArray.push(nowAllTagText.join(","));
}

//window.alert=function (s) {}			//如果不想被alert对话框打扰，取消此句的注释即可

! function() { //每天一次检查新版本
	function setCookie(name, value, days) {
		var exp = new Date();
		exp.setTime(exp.getTime() + days * 24 * 60 * 60 * 1000);
		document.cookie = name + "=" + escape(value) + ";expires=" + exp.toGMTString() + ";path=/";
	}

	function getCookie(name) {
		var arr = document.cookie.match(new RegExp("(^| )" + name + "=([^;]*)(;|$)"));
		if (arr != null)
			return unescape(arr[2]);
		return null;
	}
	var oneDayMs = 86400000;
	var d = new Date();
	if (getCookie("preCheck") === null) {
		setCookie("preCheck", d.getTime(), 365);
	} else {
		if (d.getTime() - Number(getCookie("preCheck")) > oneDayMs) {
			$.ajax({
				url: "http://saber.xn--6qq986b3xl/demo/checknewv2.php",
				type: "get",
				async: true,
				cache: false,
				dataType: "json",
				success: function(data) {
					if (data["ver"] > _thisVer) {
						setCookie("preCheck", d.getTime(), 365);
						if (window.confirm("download_pixivimg有新版本!\n现在的版本是" + _thisVer + ",最新版本为" + data["ver"] + "。\n新版本主要更新内容如下：" + data["whatsnew"] + "\n是否查看新版本？")) {
							window.open("http://www.saber.xn--6qq986b3xl/?p=2664");
						}
					} else {
						setCookie("preCheck", d.getTime(), 365);
					}
				}
			});
		}
	}
}()
if (window.location.href.indexOf("illust_id") > -1) { //1.on_illust
	! function() {
		! function(a) {
			var b = a.prototype,
				c = b.parseFromString;
			try {
				if ((new a).parseFromString("", "text/html")) return
			} catch (d) {}
			b.parseFromString = function(a, b) {
				if (/^\s*text\/html\s*(?:;|$)/i.test(b)) {
					var d = document.implementation.createHTMLDocument("");
					return a.toLowerCase().indexOf("<!doctype") > -1 ? d.documentElement.innerHTML = a : d.body.innerHTML = a, d
				}
				return c.apply(this, arguments)
			}
		}(DOMParser);
		var parser = new DOMParser();

		var outputInfo = document.createElement("div");
		outputInfo.id = "outputInfo";
		outputInfo.style.cssText = "background: #fff;padding: 10px;font-size: 14px;margin:6px auto;width:950px;";

		var doc1, doc1url, nowimgTitle, nowhtml, loopNumIn;
		var imgNum = 0;
		var maxGetNum = -1; //限制的最大下载作品数，含当前作品页。需要限制的话改成数字，不需要则设置为【-1】，而不是0。注意一个作品里可能有多张图片、如有需要修改此数字
		var imgUrlList = [];
		var imgTitle = [];

		function output() {
			imgNum++;
			$(outputInfo).html(nowhtml + "<br>已获取" + imgNum + "张图片网址");
		}

		function ajaxfordoc1(url) {
			$.ajax({
				url: url,
				type: "get",
				async: true,
				cache: false,
				dataType: "text",
				success: function(data) {
					doc1 = parser.parseFromString(data, "text/html");
					doc1_jq = $(doc1);
					if (!!doc1_jq.find(".original-image")[0]) { //如果是单图
						imgUrlList[imgNum] = doc1_jq.find(".original-image").attr("data-src");
						imgTitle.push(doc1_jq.find(".work-info .title").text());
						addTagToArray();
						output();
					} else if (!!doc1_jq.find(".works_display")[0]) { //单图以外的情况
						if (!!$(doc1).find(".full-screen._ui-tooltip")[0]) { //如果是动图 DOMParser之后无法解析（找到）canvas标签，不然判断更简单
							imgUrlList[imgNum] = doc1_jq.find("#wrapper script").eq(0).text().split("\"src\":\"")[2].split("\",\"mime_type")[0].replace(/\\/g, ""); //DOMParser之后js不会执行，所以无法用p站自己的动图变量来获取动图网址了
							imgTitle.push(doc1_jq.find(".work-info .title").text());
							addTagToArray();
							output();
						} else {
							if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=manga") > -1) { //如果有mode=manga，是多图
								_allmanga.push(doc1_jq.find("link[rel='alternate']")[0].href.split("illust_id=")[1].split("&")[0]); //将多图作品的id追加到标识多图的数组里
								nowimgTitle = doc1_jq.find(".work-info .title").text();
								var pNum = Number(doc1_jq.find("ul.meta li").eq(1).text().split(" ")[1].split("P")[0]); //P数
								var thumbHref = doc1_jq.find(".works_display img").attr("src"); //缩略图url
								var bigImgHref = thumbHref.replace("600x600", "1200x1200"); //第一张大图的url
								var imgUrlSplit = bigImgHref.split("p0");
								for (var i = pNum - 1; i >= 0; i--) {
									imgUrlList[imgNum] = (imgUrlSplit[0] + "p" + i + imgUrlSplit[1]).replace("c/1200x1200/img-master", "img-original").replace("_master1200", "").replace("jpg", "png");
									imgTitle.push(nowimgTitle);
									addTagToArray();
									output();
								};
							} else if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=big") > -1) { //对于mode=big的情况，不再进行跳转。因为没有refer会导致big页跳转回作品页，那样会抓取错误。
								_allmanga.push(doc1_jq.find(".works_display a").eq(0).attr("href").split("illust_id=")[1]);
								var trueurl = doc1_jq.find(".bookmark_modal_thumbnail").attr("data-src");
								trueurl = trueurl.replace("c/150x150/img-master", "img-original");
								trueurl = trueurl.replace("_master1200", "");
								imgUrlList[imgNum] = trueurl;
								imgTitle.push(doc1_jq.find(".work-info .title").text());
								addTagToArray();
								output();
							}
						}
					}
					if (maxGetNum > 0) {
						maxGetNum--;
					}
					if (!!doc1_jq.find(".after a")[0] && maxGetNum === -1 || !!doc1_jq.find(".after a")[0] && maxGetNum > 0) { //如果存在下一个作品，则
						doc1url = "https://www.pixiv.net/" + doc1_jq.find(".after a").eq(0).attr("href");
						ajaxfordoc1(doc1url);
					} else { //没有剩余作品
						ok(loopNumIn);
					}
				},
				statusCode: { //如果发生了错误则跳过该url
					0: function() {
						//ERR_CONNECTION_RESET
						ajaxfordoc1(allPageUrl[0]);
						console.log('请求的url不可访问');
					},
					403: function() {
						//403错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('无权访问请求的ur');
					},
					404: function() {
						//404错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('未找到该页面');
					}
				}
			});
		}


		//获取网址成功立即下载
		function ok(loopNumIn) {
			$(outputInfo).html($(outputInfo).html() + "<br>获取完毕，共" + imgUrlList.length + "个图片地址，现在开始下载<br><br>");
			var nowHtml = $(outputInfo).html();
			var reg = new RegExp(/'|#|&|\\|\/|:|\?|"|>|<|\*|\|/g); //将以下字符串替换为空格： ' # \ / : ? " < > * | 其中'会导致php创建文件时路径异常而失败，#则是不能用在url里，否则从#开始往后的字符都不会被当做是参数。&也去掉。剩下几个是windows中不允许做文件名的字符
			var artname = ($(".user-link")[0].href.split("?")[1].split("=")[1] + "_" + $(".user").eq(0).text()).replace(reg, " "); //画师id和名字，形如 id=1313987_梅
			var loopNum = loopNumIn;
			var length = imgUrlList.length; //这个变量用来对比验证批次请求是否全部完成
			var length2 = length; //这个变量用在每张图片下载成功之后，然后自减1
			var send = 0; //已成功获取的数量的
			var send2 = 0; //已发送的请求数量

			function fenpi(loopNum) {
				if (length2 < loopNum) { //url数量少于设置的请求数则发送url的实际数量
					loopNum = length2;
				};
				for (var i = 0; i < loopNum; i++) {
					var d = imgUrlList[0].split("/img/")[1].split("/"); //分割取出时间和文件名 ["2008", "06", "04", "23", "29", "25", "921663_p0.jpg"]
					var aid = d[6].split("_")[0]; //图片id
					var ismanga = 0;
					if (_allmanga.indexOf(aid) > -1) {
						ismanga = 1;
					}
					$.ajax({
						url: _phpPatch + "?url=" + encodeURI(imgUrlList[0] + "&aid=id" + aid + "&title=" + imgTitle[0].replace(reg, " ") + "&ismanga=" + ismanga + "&year=" + d[0] + "&month=" + d[1] + "&day=" + d[2] + "&h=" + d[3] + "&m=" + d[4] + "&s=" + d[5] + "&filename=" + d[6].replace(reg, " ") + "&artname=id" + artname.replace(reg, " ") + "&tag=" + tagArray[0].replace(reg, " ")),
						type: "get",
						async: true,
						cache: false,
						dataType: "text",
						success: function(data) {
							if (data !== "" && data.indexOf("fopen") > -1) { //php文件在成功时返回值是""。
								var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
								$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Warning：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
								nowHtml = $(outputInfo).html();
							}
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								imgNum = 0;
								alert("下载完毕！");
							};
						},
						error: function() {
							var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
							$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Error：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
							nowHtml = $(outputInfo).html();
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								imgNum = 0;
								alert("下载完毕！");
							};
						}
					});
					send2++;
					imgUrlList.shift();
					imgTitle.shift();
					tagArray.shift();
				}
			}

			fenpi(loopNum);
		}

		(function() {
			var startBotton = document.createElement("div");
			$(".reaction-container")[0].insertBefore(startBotton, $(".bookmark-container")[0]);
			$(startBotton).text("从本页开始下载图片");
			startBotton.style.cssText = "background: #DE2D35;border-radius: 3px;color: #fff;text-align: center;padding: 2px 5px;cursor: pointer;position: absolute;top:auto;left: 480px;";
			startBotton.addEventListener("click", function() {
				$("._global-header").eq(0).before(outputInfo);
				maxGetNum = prompt("如果要下载全部作品，请保持默认值。\n如果需要设置下载的作品数，请输入从1开始的数字，1为仅下载当前作品。", "-1");
				if (maxGetNum === null || maxGetNum === "0" || ~~Number(maxGetNum) < -1) {
					return false;
				} else if (~~Number(maxGetNum) > 0) {
					maxGetNum = ~~Number(maxGetNum);
					$(outputInfo).html("向下获取" + maxGetNum + "个作品数");
				} else {
					maxGetNum = -1;
					$(outputInfo).html("向下获取所有作品");
				}
				loopNumIn = prompt("最多允许同时下载多少张图片？\n如果动图特别多，建议设置为1或2", "10");
				if (loopNumIn === null || Number(loopNumIn) <= 0 || isNaN(Number(loopNumIn))) {
					alert("参数不正确！本次操作无效。");
					return false;
				} else {
					loopNumIn = ~~Number(loopNumIn);
					$(outputInfo).html($(outputInfo).html() + "　下载时每批次数量为" + loopNumIn);
				}
				nowhtml = $(outputInfo).html();
				//开始获取图片
				ajaxfordoc1(window.location.href);
			}, false);
		})();
	}()
} else if ((window.location.href.indexOf("member_illust.php?id=") > -1 || window.location.href.indexOf("&id=") > -1) && (window.location.href.indexOf("&tag") == -1 && window.location.href.indexOf("?tag") == -1)) { //2.on_illust_list
	! function() {
		! function(a) {
			var b = a.prototype,
				c = b.parseFromString;
			try {
				if ((new a).parseFromString("", "text/html")) return
			} catch (d) {}
			b.parseFromString = function(a, b) {
				if (/^\s*text\/html\s*(?:;|$)/i.test(b)) {
					var d = document.implementation.createHTMLDocument("");
					return a.toLowerCase().indexOf("<!doctype") > -1 ? d.documentElement.innerHTML = a : d.body.innerHTML = a, d
				}
				return c.apply(this, arguments)
			}
		}(DOMParser);
		var parser = new DOMParser();

		var doc0, doc1, nowimgTitle, nowhtml, loopNumIn;
		var allowWork = true; //如果本次抓取未完成，则不
		var paged = 0; //向下第几页
		var imgNum = 0;
		var maxGetNum = -1; //限制的最大下载作品数，含当前作品页。需要限制的话改成数字，不需要则设置为【-1】，而不是0。注意一个作品里可能有多张图片、如有需要修改此数字
		var allPageUrl = [];
		var allPageUrl = [];
		var imgUrlList = [];
		var imgTitle = [];
		var baseUrl = window.location.href.split("&p=")[0] + "&p=";

		if (!!$(".page-list .current")[0]) { //如果显示有页码
			var startPageNo = Number($(".page-list .current").eq(0).text()); //最开始时的页码
		} else { //否则认为只有1页
			var startPageNo = 1;
		}

		function startGet() {
			if (!allowWork) {
				alert("当前任务尚未完成，请等到提示完成之后再设置新的任务。");
				return false;
			};
			var wantPageNum = prompt("如果不限制下载的页数，请不要修改此默认值。\n如果要限制下载的页数，请输入从1开始的数字，1为仅下载本页。", "-1");
			if (~~Number(wantPageNum) < 1 && wantPageNum !== "-1") {
				$("#outputInfo").html($("#outputInfo").html() + "参数不合法，本次操作已取消。<br>");
				return false;
			};
			loopNumIn = prompt("最多允许同时下载多少张图片？\n如果动图特别多，建议设置为1或2", "10");
			if (loopNumIn === null || Number(loopNumIn) <= 0 || isNaN(Number(loopNumIn))) {
				alert("参数不正确！本次操作无效。");
				return false;
			} else {
				loopNumIn = ~~Number(loopNumIn);
			}
			if (notdown.indexOf("1") > -1 && notdown.indexOf("2") > -1 && notdown.indexOf("3") > -1) {
				alert("由于您排除了所有作品类型，本次任务已取消。")
				return false;
			};
			if (~~Number(wantPageNum) >= 1) {
				wantPageNum = ~~Number(wantPageNum);
				$("#outputInfo").html($("#outputInfo").html() + "任务开始\n本次任务条件：从本页开始下载" + wantPageNum + "页");
			} else if (wantPageNum === "-1") {
				wantPageNum = -1;
				$("#outputInfo").html($("#outputInfo").html() + "任务开始\n本次任务条件：下载所有页面");
			}
			if (notdown !== "") {
				$("#outputInfo").html($("#outputInfo").html() + "<br>本次任务设置了排除作品：" + notdown);
			}
			if ($("#nottaginput").val() !== nottagdef) {
				$("#outputInfo").html($("#outputInfo").html() + "<br>本次任务设置了过滤tag：" + $("#nottaginput").val());
				nottagArray = $("#nottaginput").val().split(",");
				if (nottagArray[nottagArray.length - 1 === ""]) {
					nottagArray.pop();
				};
			};
			nowhtml = $("#outputInfo").html();

			function getpage(url) {
				$.ajax({
					url: baseUrl + (startPageNo + paged),
					type: "get",
					async: true,
					cache: false,
					dataType: "text",
					success: function(data) {
						paged++;
						doc0 = parser.parseFromString(data, "text/html");
						var doc0_jq = $(doc0);
						var allPicArea = doc0_jq.find("._image-items .image-item");
						for (var i = 0; i < allPicArea.length; i++) {
							if (!allPicArea.eq(i).find("a")[0]) { //如果列表中的这个作品没有a标签，则是被删除、或非公开等错误项
								continue;
							};
							if (allPicArea.eq(i).find("a").eq(0).attr("class").indexOf("multiple") > -1) {
								if (notdown.indexOf("1") == -1) { //如果没有排除多图
									allPageUrl.push(allPicArea.eq(i).find("a").eq(0).attr("href"));
								}
							} else if (allPicArea.eq(i).find("a").eq(0).attr("class").indexOf("ugoku-illust") > -1) {
								if (notdown.indexOf("2") == -1) { //如果没有排除多图
									allPageUrl.push(allPicArea.eq(i).find("a").eq(0).attr("href"));
								}
							} else { //这时候除了单图，还有可能是manga，里面最后是mode=big，也当做单图处理
								if (notdown.indexOf("3") == -1) { //如果没有排除单图
									allPageUrl.push(allPicArea.eq(i).find("a").eq(0).attr("href"));
								}
							}
						};
						$("#outputInfo").html(nowhtml + "<br>已抓取作品列表" + paged + "个页面");
						//判断任务状态
						if (!doc0_jq.find(".next ._button")[0] || paged == wantPageNum) { //如果没有下一页的按钮或者抓取完指定页面
							allowWork = true;
							paged = 0;
							$("#outputInfo").html($("#outputInfo").html() + "<br>作品列表页面抓取完成，开始获取图片网址");
							nowhtml = $("#outputInfo").html();
							if (allPageUrl.length < ajax1Bingfa) {
								ajax1Bingfa = allPageUrl.length;
							}
							for (var i = 0; i < ajax1Bingfa; i++) {
								setTimeout(ajaxfordoc1(allPageUrl[0]), i * ajax1Jiange);
							}
						} else {
							getpage();
						};
					}
				});
			}

			allowWork = false; //开始执行时更改许可状态
			getpage();
		}

		function output() {
			imgNum++;
			$(outputInfo).html(nowhtml + "<br>已获取" + imgNum + "张图片网址");
		}

		function ajaxfordoc1(url) {
			allPageUrl.shift();
			$.ajax({
				url: url,
				type: "get",
				async: true,
				cache: false,
				dataType: "text",
				success: function(data) {
					var tagIsFound = false;
					doc1 = parser.parseFromString(data, "text/html");
					doc1_jq = $(doc1);
					var nowAllTag = doc1_jq.find("li.tag");
					outerloop: //命名外圈语句
						for (var i = nowAllTag.length - 1; i >= 0; i--) {
							var nowTag = nowAllTag.eq(i).find(".text").text();
							for (var ii = nottagArray.length - 1; ii >= 0; ii--) {
								if (nowTag === nottagArray[ii]) {
									tagIsFound = true;
									break outerloop;
								}
							};
						};
					if (!!doc1_jq.find(".original-image")[0] && !tagIsFound) { //如果是单图
						imgUrlList[imgNum] = doc1_jq.find(".original-image").attr("data-src");
						imgTitle.push(doc1_jq.find(".work-info .title").text());
						addTagToArray();
						output();
					} else if (!!doc1_jq.find(".works_display")[0] && !tagIsFound) { //单图以外的情况
						if (!!$(doc1).find(".full-screen._ui-tooltip")[0]) { //如果是动图 DOMParser之后无法解析（找到）canvas标签，不然判断更简单
							imgUrlList[imgNum] = doc1_jq.find("#wrapper script").eq(0).text().split("\"src\":\"")[2].split("\",\"mime_type")[0].replace(/\\/g, ""); //DOMParser之后js不会执行，所以无法用p站自己的动图变量来获取动图网址了
							imgTitle.push(doc1_jq.find(".work-info .title").text());
							addTagToArray();
							output();
						} else {
							if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=manga") > -1) { //如果有mode=manga，是多图
								_allmanga.push(doc1_jq.find("link[rel='alternate']")[0].href.split("illust_id=")[1].split("&")[0]); //将多图作品的id追加到标识多图的数组里
								nowimgTitle = doc1_jq.find(".work-info .title").text();
								var pNum = Number(doc1_jq.find("ul.meta li").eq(1).text().split(" ")[1].split("P")[0]); //P数
								var thumbHref = doc1_jq.find(".works_display img").attr("src"); //缩略图url
								var imgUrlSplit = thumbHref.replace("600x600", "1200x1200").split("p0");
								for (var i = pNum - 1; i >= 0; i--) {
									imgUrlList[imgNum] = (imgUrlSplit[0] + "p" + i + imgUrlSplit[1]).replace("c/1200x1200/img-master", "img-original").replace("_master1200", "").replace("jpg", "png");
									imgTitle.push(nowimgTitle);
									addTagToArray();
									output();
								};
							} else if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=big") > -1) { //对于mode=big的情况，不再进行跳转
								_allmanga.push(doc1_jq.find(".works_display a").eq(0).attr("href").split("illust_id=")[1]);
								var trueurl = doc1_jq.find(".bookmark_modal_thumbnail").attr("data-src");
								trueurl = trueurl.replace("c/150x150/img-master", "img-original");
								trueurl = trueurl.replace("_master1200", "");
								imgUrlList[imgNum] = trueurl;
								imgTitle.push(doc1_jq.find(".work-info .title").text());
								addTagToArray();
								output();
							}
						}
					}
					if (maxGetNum > 0) {
						maxGetNum--;
					}
					if (allPageUrl.length > 0) { //如果存在下一个作品，则
						ajaxfordoc1(allPageUrl[0]);
					} else { //没有剩余作品
						ajax1No++;
						if (ajax1No === ajax1Bingfa) { //如果所有并发请求都执行完毕
							ok(loopNumIn);
							ajax1No = 0; //复位
						}
					}
				},
				statusCode: { //如果发生了错误则跳过该url
					0: function() {
						//ERR_CONNECTION_RESET
						ajaxfordoc1(allPageUrl[0]);
						console.log('请求的url不可访问');
					},
					403: function() {
						//403错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('无权访问请求的ur');
					},
					404: function() {
						//404错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('未找到该页面');
					}
				}
			});
		}


		//获取网址成功立即下载
		function ok(loopNumIn) {
			$(outputInfo).html($(outputInfo).html() + "<br>获取完毕，现在开始下载<br>");
			if (imgUrlList.length == 0) {
				$(outputInfo).html($(outputInfo).html() + ("<br>没有作品需要下载，本次任务已完成。<br><br>"));
				imgNum = 0;
				allowWork = true;
				alert("没有作品需要下载，本次任务已完成。");
			};
			var nowHtml = $(outputInfo).html();
			var reg = new RegExp(/'|#|&|\\|\/|:|\?|"|>|<|\*|\|/g); //将以下字符串替换为空格： ' # \ / : ? " < > * | 其中'会导致php创建文件时路径异常而失败，#则是不能用在url里，否则从#开始往后的字符都不会被当做是参数。剩下几个是windows中不允许做文件名的字符。至此困扰我好久的偶尔漏下图片的问题终于有眉目了
			var artname = ($(".user-link")[0].href.split("?")[1].split("=")[1] + "_" + $(".user").eq(0).text()).replace(reg, " ");
			var loopNum = loopNumIn;
			var length = imgUrlList.length; //这个变量用来对比验证批次请求是否全部完成
			var length2 = length; //这个变量用在每张图片下载成功之后，然后自减1
			var send = 0; //已成功获取的数量的
			var send2 = 0; //已发送的请求数量

			function fenpi(loopNum) {
				if (length2 < loopNum) { //url数量少于设置的请求数则发送url的实际数量
					loopNum = length2;
				};
				for (var i = 0; i < loopNum; i++) {
					var d = imgUrlList[0].split("/img/")[1].split("/"); //分割取出时间和文件名 ["2008", "06", "04", "23", "29", "25", "921663_p0.jpg"]
					var aid = d[6].split("_")[0]; //图片id
					var ismanga = 0;
					if (_allmanga.indexOf(aid) > -1) {
						ismanga = 1;
					}
					$.ajax({
						url: _phpPatch + "?url=" + encodeURI(imgUrlList[0] + "&aid=id" + aid + "&title=" + imgTitle[0].replace(reg, " ") + "&ismanga=" + ismanga + "&year=" + d[0] + "&month=" + d[1] + "&day=" + d[2] + "&h=" + d[3] + "&m=" + d[4] + "&s=" + d[5] + "&filename=" + d[6] + "&artname=id" + artname + "&tag=" + tagArray[0].replace(reg, " ") + "&startUrl=" + startUrl),
						type: "get",
						async: true,
						cache: false,
						dataType: "text",
						success: function(data) {
							if (data !== "" && data.indexOf("fopen") > -1) { //php文件在成功时返回值是""。
								var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
								$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Warning：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
								nowHtml = $(outputInfo).html();
							}
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								imgNum = 0;
								allowWork = true;
								alert("下载完毕！");
							};
						},
						error: function() {
							var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
							$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Error：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
							nowHtml = $(outputInfo).html();
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								imgNum = 0;
								allowWork = true;
								alert("下载完毕！");
							};
						}
					});
					send2++;
					imgUrlList.shift();
					imgTitle.shift();
					tagArray.shift();
				}
			}

			fenpi(loopNum);
		}

		var outputInfo = document.createElement("div");
		outputInfo.id = "outputInfo";
		outputInfo.style.cssText = "background: #fff;padding: 10px;font-size: 14px;margin:6px auto;width:950px;";

		(function() {
			var downloadBotton = document.createElement("div");
			document.body.appendChild(downloadBotton);
			$(downloadBotton).text("下载该画师的作品");
			$(downloadBotton).attr("title", "下载该画师的作品，如有多页，默认会下载全部。")
			downloadBotton.style.cssText = "background: #00A514;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 335px;right: 0;z-index: 9999;cursor: pointer;";
			downloadBotton.addEventListener("click", function() {
				$("._global-header").eq(0).before(outputInfo);
				startGet();
			}, false);
		})();

		var notdown = "";
		(function() {
			var clearMultiple = document.createElement("div");
			clearMultiple.id = "clearMultiple";
			document.body.appendChild(clearMultiple);
			$(clearMultiple).text("排除指定类型的作品");
			$(clearMultiple).attr("title", "在下载前，您可以设置想要排除的作品类型。")
			clearMultiple.style.cssText = "background: #DA7002;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 385px;right: 0;z-index: 9999;cursor: pointer;";
			clearMultiple.addEventListener("click", function() {
				notdown = prompt("请设置下载时要排除的作品类型。如需多选，将多个数字连写即可\n1：排除多图\n2：排除动图\n3：排除单图", "");
				if (notdown === null) { //如果取消设置，则将返回值null改为字符串，不然无法使用indexOf
					notdown = "";
				};
			}, false);
		})();

		jQuery.focusblur = function(element, defcolor, truecolor) {
			var focusblurid = element;
			var defval = focusblurid.val(); //针对input
			focusblurid.focus(function() {
				var thisval = $(this).val();
				if (thisval == defval) {
					$(this).val("");
					$(this).css("color", truecolor);
				}
			});
			focusblurid.blur(function() {
				var thisval = $(this).val();
				if (thisval == "") {
					$(this).val(defval);
					$(this).css("color", defcolor);
				}
			});
		};

		var nottagArray = [];
		var nottagdef = "您可在下载前设置要过滤的tag，这样在下载时将不会下载含有这些tag的作品。区分大小写；如需过滤多个tag，请使用英文逗号分隔。";
		(function() {
			var nottag = document.createElement("div");
			nottag.id = "nottag";
			document.body.appendChild(nottag);
			$(nottag).text("设置需要过滤的tag");
			$(nottag).attr("title", "在下载前，您可以设置想要过滤的tag。")
			nottag.style.cssText = "background: #DA7002;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 435px;right: 0;z-index: 9999;cursor: pointer;";

			var nottaginput = document.createElement("textarea");
			nottaginput.id = "nottaginput";
			nottaginput.style.cssText = "width: 600px;height: 100px;font-size: 12px;margin:6px auto;background:#fff;colir:#bbb;padding:7px;display:none;";
			document.body.insertBefore(nottaginput, $("_global-header")[0]);
			$("#nottaginput").val(nottagdef);
			$.focusblur($("#nottaginput"), "#bbb", "#333");

			nottag.addEventListener("click", function() {
				$("#nottaginput").toggle();
				if ($("#nottaginput").is(":visible")) {
					$("#nottaginput").css("display", "block");
					if (navigator.userAgent.indexOf('AppleWebKit') > -1) { //如果是chrome内核，则
						document.body.scrollTop = 0;
					} else { //否则
						document.documentElement.scrollTop = 0; //IE和火狐需要这一句
					}
				};
			}, false);
		})();

	}()
} else if ((window.location.href.indexOf("bookmark.php") > -1 && window.location.href.indexOf("tag=") > -1) || (window.location.href.indexOf("member_illust.php?id=") > -1 && window.location.href.indexOf("&tag=") > -1)) { //3.on_tagpage
	! function() {
		! function(a) {
			var b = a.prototype,
				c = b.parseFromString;
			try {
				if ((new a).parseFromString("", "text/html")) return
			} catch (d) {}
			b.parseFromString = function(a, b) {
				if (/^\s*text\/html\s*(?:;|$)/i.test(b)) {
					var d = document.implementation.createHTMLDocument("");
					return a.toLowerCase().indexOf("<!doctype") > -1 ? d.documentElement.innerHTML = a : d.body.innerHTML = a, d
				}
				return c.apply(this, arguments)
			}
		}(DOMParser);
		var parser = new DOMParser();

		var doc0, doc1, nowimgTitle, nowhtml, loopNumIn;
		var allowWork = true; //如果本次抓取未完成，则不
		var paged = 0; //向下第几页
		var imgNum = 0;
		var maxGetNum = -1; //限制的最大下载作品数，含当前作品页。需要限制的话改成数字，不需要则设置为【-1】，而不是0。注意一个作品里可能有多张图片、如有需要修改此数字
		var allPageUrl = [];
		var allPageUrl = [];
		var imgUrlList = [];
		var imgTitle = [];
		var baseUrl = window.location.href.split("&p=")[0] + "&p=";

		if (!!$(".page-list .current")[0]) { //如果显示有页码
			var startPageNo = Number($(".page-list .current").eq(0).text()); //最开始时的页码
		} else { //否则认为只有1页
			var startPageNo = 1;
		}

		function startGet() {
			if (!allowWork) {
				alert("当前任务尚未完成，请等到提示完成之后再设置新的任务。");
				return false;
			};
			if (window.location.href.indexOf("tag") == -1) {
				alert("当前页面不是tag页，或是'全部'的tag。请选择一个作为分类的tag页。");
				return false;
			};
			var wantPageNum = prompt("如果不限制下载的页数，请不要修改此默认值。\n如果要限制下载的页数，请输入从1开始的数字，1为仅下载本页。", "-1");
			if (~~Number(wantPageNum) < 1 && wantPageNum !== "-1") {
				$("#outputInfo").html($("#outputInfo").html() + "参数不合法，本次操作已取消。<br>");
				return false;
			};
			loopNumIn = prompt("最多允许同时下载多少张图片？\n如果动图特别多，建议设置为1或2", "10");
			if (loopNumIn === null || Number(loopNumIn) <= 0 || isNaN(Number(loopNumIn))) {
				alert("参数不正确！本次操作无效。");
				return false;
			} else {
				loopNumIn = ~~Number(loopNumIn);
			}
			if (notdown.indexOf("1") > -1 && notdown.indexOf("2") > -1 && notdown.indexOf("3") > -1) {
				alert("由于您排除了所有作品类型，本次任务已取消。")
				return false;
			};
			if (~~Number(wantPageNum) >= 1) {
				wantPageNum = ~~Number(wantPageNum);
				$("#outputInfo").html($("#outputInfo").html() + "任务开始\n本次任务条件：从本页开始下载" + wantPageNum + "页");
			} else if (wantPageNum === "-1") {
				wantPageNum = -1;
				$("#outputInfo").html($("#outputInfo").html() + "任务开始\n本次任务条件：下载所有页面");
			}
			if (notdown !== "") {
				$("#outputInfo").html($("#outputInfo").html() + "<br>本次任务设置了排除作品：" + notdown);
			}
			nowhtml = $("#outputInfo").html();

			function getpage(url) {
				$.ajax({
					url: baseUrl + (startPageNo + paged),
					type: "get",
					async: true,
					cache: false,
					dataType: "text",
					success: function(data) {
						paged++;
						doc0 = parser.parseFromString(data, "text/html");
						var doc0_jq = $(doc0);
						var allPicArea = doc0_jq.find("._image-items .image-item");
						for (var i = 0; i < allPicArea.length; i++) {
							if (!allPicArea.eq(i).find("a")[0]) { //如果列表中的这个作品没有a标签，则是被删除、或非公开等错误项
								continue;
							};
							if (allPicArea.eq(i).find("a").eq(0).attr("class").indexOf("multiple") > -1) {
								if (notdown.indexOf("1") == -1) { //如果没有排除多图
									allPageUrl.push(allPicArea.eq(i).find("a").eq(0).attr("href"));
								}
							} else if (allPicArea.eq(i).find("a").eq(0).attr("class").indexOf("ugoku-illust") > -1) {
								if (notdown.indexOf("2") == -1) { //如果没有排除多图
									allPageUrl.push(allPicArea.eq(i).find("a").eq(0).attr("href"));
								}
							} else { //这时候除了单图，还有可能是manga，里面最后是mode=big，也当做单图处理
								if (notdown.indexOf("3") == -1) { //如果没有排除单图
									allPageUrl.push(allPicArea.eq(i).find("a").eq(0).attr("href"));
								}
							}
						};
						$("#outputInfo").html(nowhtml + "<br>已抓取本tag" + paged + "个页面");
						//判断任务状态
						if (!doc0_jq.find(".next ._button")[0] || paged == wantPageNum) { //如果没有下一页的按钮或者抓取完指定页面
							allowWork = true;
							paged = 0;
							$("#outputInfo").html($("#outputInfo").html() + "<br>tag页面抓取完成，开始获取图片网址");
							nowhtml = $("#outputInfo").html();
							if (allPageUrl.length < ajax1Bingfa) {
								ajax1Bingfa = allPageUrl.length;
							}
							for (var i = 0; i < ajax1Bingfa; i++) {
								setTimeout(ajaxfordoc1(allPageUrl[0]), i * ajax1Jiange);
							}
						} else {
							getpage();
						};
					}
				});
			}

			allowWork = false; //开始执行时更改许可状态
			getpage();
		}

		function output() {
			imgNum++;
			$(outputInfo).html(nowhtml + "<br>已获取" + imgNum + "张图片网址");
		}

		function ajaxfordoc1(url) {
			allPageUrl.shift();
			$.ajax({
				url: url,
				type: "get",
				async: true,
				cache: false,
				dataType: "text",
				success: function(data) {
					doc1 = parser.parseFromString(data, "text/html");
					doc1_jq = $(doc1);
					if (!!doc1_jq.find(".original-image")[0]) { //如果是单图
						imgUrlList[imgNum] = doc1_jq.find(".original-image").attr("data-src");
						imgTitle.push(doc1_jq.find(".work-info .title").text());
						addTagToArray();
						output();
					} else if (!!doc1_jq.find(".works_display")[0]) { //单图以外的情况
						if (!!$(doc1).find(".full-screen._ui-tooltip")[0]) { //如果是动图 DOMParser之后无法解析（找到）canvas标签，不然判断更简单
							imgUrlList[imgNum] = doc1_jq.find("#wrapper script").eq(0).text().split("\"src\":\"")[2].split("\",\"mime_type")[0].replace(/\\/g, ""); //DOMParser之后js不会执行，所以无法用p站自己的动图变量来获取动图网址了
							imgTitle.push(doc1_jq.find(".work-info .title").text());
							addTagToArray();
							output();
						} else {
							if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=manga") > -1) { //如果有mode=manga，是多图
								_allmanga.push(doc1_jq.find("link[rel='alternate']")[0].href.split("illust_id=")[1].split("&")[0]); //将多图作品的id追加到标识多图的数组里
								nowimgTitle = doc1_jq.find(".work-info .title").text();
								var pNum = Number(doc1_jq.find("ul.meta li").eq(1).text().split(" ")[1].split("P")[0]); //P数
								var thumbHref = doc1_jq.find(".works_display img").attr("src"); //缩略图url
								var bigImgHref = thumbHref.replace("600x600", "1200x1200"); //第一张大图的url
								var imgUrlSplit = bigImgHref.split("p0");
								for (var i = pNum - 1; i >= 0; i--) {
									imgUrlList[imgNum] = (imgUrlSplit[0] + "p" + i + imgUrlSplit[1]).replace("c/1200x1200/img-master", "img-original").replace("_master1200", "").replace("jpg", "png");
									imgTitle.push(nowimgTitle);
									addTagToArray();
									output();
								};
							} else if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=big") > -1) { //对于mode=big的情况，不再进行跳转
								_allmanga.push(doc1_jq.find(".works_display a").eq(0).attr("href").split("illust_id=")[1]);
								var trueurl = doc1_jq.find(".bookmark_modal_thumbnail").attr("data-src");
								trueurl = trueurl.replace("c/150x150/img-master", "img-original");
								trueurl = trueurl.replace("_master1200", "");
								imgUrlList[imgNum] = trueurl;
								imgTitle.push(doc1_jq.find(".work-info .title").text());
								addTagToArray();
								output();
							}
						}
					}
					if (maxGetNum > 0) {
						maxGetNum--;
					}
					if (allPageUrl.length > 0) { //如果存在下一个作品，则
						ajaxfordoc1(allPageUrl[0]);
					} else { //没有剩余作品
						ajax1No++;
						if (ajax1No === ajax1Bingfa) { //如果所有并发请求都执行完毕
							ok(loopNumIn);
							ajax1No = 0; //复位
						}
					}
				},
				statusCode: { //如果发生了错误则跳过该url
					0: function() {
						//ERR_CONNECTION_RESET
						ajaxfordoc1(allPageUrl[0]);
						console.log('请求的url不可访问');
					},
					400: function() {
						//400错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('该作品已被删除'); //在收藏的作品列表中，有些作品被作者删除了，却还显示有“编辑”按钮（有些是没有这个按钮的）。点击这个按钮会跳转到错误的“编辑收藏”页面，导致400错误。本状态码指示程序在这种情况下跳过。这个判断仅在下载书签作品的两部分js里添加。
					},
					403: function() {
						//403错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('无权访问请求的url');
					},
					404: function() {
						//404错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('未找到该页面');
					}
				}
			});
		}


		//获取网址成功立即下载
		function ok(loopNumIn) {
			$(outputInfo).html($(outputInfo).html() + "<br>获取完毕，现在开始下载<br>");
			if (imgUrlList.length == 0) {
				$(outputInfo).html($(outputInfo).html() + ("<br>没有作品需要下载，本次任务已完成。<br><br>"));
				imgNum = 0;
				allowWork = true;
				alert("没有作品需要下载，本次任务已完成。");
			};
			var nowHtml = $(outputInfo).html();
			var reg = new RegExp(/'|#|&|\\|\/|:|\?|"|>|<|\*|\|/g); //将以下字符串替换为空格： ' # \ / : ? " < > * | 其中'会导致php创建文件时路径异常而失败，#则是不能用在url里，否则从#开始往后的字符都不会被当做是参数。剩下几个是windows中不允许做文件名的字符。至此困扰我好久的偶尔漏下图片的问题终于有眉目了
			if (!$(".user-link")[0]) { //如果没有画师名 那就是在自己的收藏里的tag页面
				var artname = ("tag_" + $(".tag-badge").text() + "_formbookmark").replace(reg, " "); //形如 tag_Miku_formbookmark
			} else { //在其他人的
				if (window.location.href.indexOf("bookmark.php") > -1) { //在其他人的收藏页
					var artname = "tag_" + ($(".tag-badge").text() + "_bookmarkby_id" + ($(".user-link")[0].href.split("?")[1].split("=")[1] + "_" + $(".user-link h1").text())).replace(reg, " "); //形如 tag_saber_bookmarkby_id88888_画师名
				} else { //在其他人的tag页
					var artname = "tag_" + ($(".tag-badge").text() + "_id" + ($(".user-link")[0].href.split("?")[1].split("=")[1] + "_" + $(".user").eq(0).text())).replace(reg, " "); //形如 tag_saber_id88888_画师名
				}
			}

			var loopNum = loopNumIn;
			var length = imgUrlList.length; //这个变量用来对比验证批次请求是否全部完成
			var length2 = length; //这个变量用在每张图片下载成功之后，然后自减1
			var send = 0; //已成功获取的数量的
			var send2 = 0; //已发送的请求数量

			function fenpi(loopNum) {
				if (length2 < loopNum) { //url数量少于设置的请求数则发送url的实际数量
					loopNum = length2;
				};
				for (var i = 0; i < loopNum; i++) {
					var d = imgUrlList[0].split("/img/")[1].split("/"); //分割取出时间和文件名 ["2008", "06", "04", "23", "29", "25", "921663_p0.jpg"]
					var aid = d[6].split("_")[0]; //图片id
					var ismanga = 0;
					if (_allmanga.indexOf(aid) > -1) {
						ismanga = 1;
					}
					$.ajax({
						url: _phpPatch + "?url=" + encodeURI(imgUrlList[0] + "&aid=id" + aid + "&title=" + imgTitle[0].replace(reg, " ") + "&ismanga=" + ismanga + "&year=" + d[0] + "&month=" + d[1] + "&day=" + d[2] + "&h=" + d[3] + "&m=" + d[4] + "&s=" + d[5] + "&filename=" + d[6] + "&artname=" + artname + "&tag=" + tagArray[0].replace(reg, " ") + "&startUrl=" + startUrl),
						type: "get",
						async: true,
						cache: false,
						dataType: "text",
						success: function(data) {
							if (data !== "" && data.indexOf("fopen") > -1) { //php文件在成功时返回值是""。
								var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
								$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Warning：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
								nowHtml = $(outputInfo).html();
							}
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								imgNum = 0;
								allowWork = true;
								alert("下载完毕！");
							};
						},
						error: function() {
							var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
							$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Error：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
							nowHtml = $(outputInfo).html();
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								imgNum = 0;
								allowWork = true;
								alert("下载完毕！");
							};
						}
					});
					send2++;
					imgUrlList.shift();
					imgTitle.shift();
					tagArray.shift();
				}
			}

			fenpi(loopNum);
		}

		var outputInfo = document.createElement("div");
		outputInfo.id = "outputInfo";
		outputInfo.style.cssText = "background: #fff;padding: 10px;font-size: 14px;margin:6px auto;width:950px;";

		(function() {
			var downloadBotton = document.createElement("div");
			document.body.appendChild(downloadBotton);
			$(downloadBotton).text("下载该tag中的作品");
			$(downloadBotton).attr("title", "下载该tag中的作品，如有多页，默认会下载全部。")
			downloadBotton.style.cssText = "background: #00A514;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 335px;right: 0;z-index: 9999;cursor: pointer;";
			downloadBotton.addEventListener("click", function() {
				$("._global-header").eq(0).before(outputInfo);
				startGet();
			}, false);
		})();

		var notdown = "";
		(function() {
			var clearMultiple = document.createElement("div");
			clearMultiple.id = "clearMultiple";
			document.body.appendChild(clearMultiple);
			$(clearMultiple).text("排除指定类型的作品");
			$(clearMultiple).attr("title", "在下载前，您可以设置想要排除的作品类型。")
			clearMultiple.style.cssText = "background: #DA7002;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 385px;right: 0;z-index: 9999;cursor: pointer;";
			clearMultiple.addEventListener("click", function() {
				notdown = prompt("请设置下载时要排除的作品类型。如需多选，将多个数字连写即可\n1：排除多图\n2：排除动图\n3：排除单图", "");
				if (notdown === null) { //如果取消设置，则将返回值null改为字符串，不然无法使用indexOf
					notdown = "";
				};
			}, false);
		})();

	}()
} else if (window.location.href.indexOf("bookmark.php") > -1 && window.location.href.indexOf("tag=") == -1) { //4.on_bookmark
	! function() {
		! function(a) {
			var b = a.prototype,
				c = b.parseFromString;
			try {
				if ((new a).parseFromString("", "text/html")) return
			} catch (d) {}
			b.parseFromString = function(a, b) {
				if (/^\s*text\/html\s*(?:;|$)/i.test(b)) {
					var d = document.implementation.createHTMLDocument("");
					return a.toLowerCase().indexOf("<!doctype") > -1 ? d.documentElement.innerHTML = a : d.body.innerHTML = a, d
				}
				return c.apply(this, arguments)
			}
		}(DOMParser);
		var parser = new DOMParser();

		var doc0, doc1, nowimgTitle, nowhtml, loopNumIn;
		var allowWork = true; //如果本次抓取未完成，则不
		var paged = 0; //向下第几页
		var imgNum = 0;
		var maxGetNum = -1; //限制的最大下载作品数，含当前作品页。需要限制的话改成数字，不需要则设置为【-1】，而不是0。注意一个作品里可能有多张图片、如有需要修改此数字
		var allPageUrl = [];
		var allPageUrl = [];
		var imgUrlList = [];
		var imgTitle = [];

		if ($(".menu-items").eq(2).find("a.current").text().indexOf("收藏") > -1) { //如果是按收藏排序

		}
		var baseUrl = window.location.href.split("?rest=show&p=")[0] + "?rest=show&p=";

		if (!!$(".page-list .current")[0]) { //如果显示有页码
			var startPageNo = Number($(".page-list .current").eq(0).text()); //最开始时的页码
			var baseUrl = "https://www.pixiv.net/bookmark.php" + $(".page-list").eq(0).find("a").eq(0).attr("href").split("&p=")[0] + "&p="; //这个基础url要根据排序方式变化，所以从页码中取值
		} else { //否则认为只有1页
			var startPageNo = 1;
			var baseUrl = window.location.href;
		}

		function startGet() {
			if (!allowWork) {
				alert("当前任务尚未完成，请等到提示完成之后再设置新的任务。");
				return false;
			};
			var wantPageNum = prompt("如果不限制下载的页数，请不要修改此默认值。\n如果要限制下载的页数，请输入从1开始的数字，1为仅下载本页。", "-1");
			if (~~Number(wantPageNum) < 1 && wantPageNum !== "-1") {
				$("#outputInfo").html($("#outputInfo").html() + "参数不合法，本次操作已取消。<br>");
				return false;
			};
			loopNumIn = prompt("最多允许同时下载多少张图片？\n如果动图特别多，建议设置为1或2", "10");
			if (loopNumIn === null || Number(loopNumIn) <= 0 || isNaN(Number(loopNumIn))) {
				alert("参数不正确！本次操作无效。");
				return false;
			} else {
				loopNumIn = ~~Number(loopNumIn);
			}
			if (notdown.indexOf("1") > -1 && notdown.indexOf("2") > -1 && notdown.indexOf("3") > -1) {
				alert("由于您排除了所有作品类型，本次任务已取消。")
				return false;
			};
			if (~~Number(wantPageNum) >= 1) {
				wantPageNum = ~~Number(wantPageNum);
				$("#outputInfo").html($("#outputInfo").html() + "任务开始\n本次任务条件：从本页开始下载" + wantPageNum + "页");
			} else if (wantPageNum === "-1") {
				wantPageNum = -1;
				$("#outputInfo").html($("#outputInfo").html() + "任务开始\n本次任务条件：下载所有页面");
			}
			if (notdown !== "") {
				$("#outputInfo").html($("#outputInfo").html() + "<br>本次任务设置了排除作品：" + notdown);
			}
			nowhtml = $("#outputInfo").html();

			function getpage(url) {
				$.ajax({
					url: baseUrl + (startPageNo + paged),
					type: "get",
					async: true,
					cache: false,
					dataType: "text",
					success: function(data) {
						paged++;
						doc0 = parser.parseFromString(data, "text/html");
						var doc0_jq = $(doc0);
						var allPicArea = doc0_jq.find("._image-items .image-item");
						for (var i = 0; i < allPicArea.length; i++) {
							if (!allPicArea.eq(i).find("a")[0]) { //如果列表中的这个作品没有a标签，则是被删除、或非公开等错误项
								continue;
							};
							if (allPicArea.eq(i).find("a").eq(0).attr("class").indexOf("multiple") > -1) {
								if (notdown.indexOf("1") == -1) { //如果没有排除多图
									allPageUrl.push(allPicArea.eq(i).find("a").eq(0).attr("href"));
								}
							} else if (allPicArea.eq(i).find("a").eq(0).attr("class").indexOf("ugoku-illust") > -1) {
								if (notdown.indexOf("2") == -1) { //如果没有排除多图
									allPageUrl.push(allPicArea.eq(i).find("a").eq(0).attr("href"));
								}
							} else { //这时候除了单图，还有可能是manga，里面最后是mode=big，也当做单图处理
								if (notdown.indexOf("3") == -1) { //如果没有排除单图
									allPageUrl.push(allPicArea.eq(i).find("a").eq(0).attr("href"));
								}
							}
						};
						$("#outputInfo").html(nowhtml + "<br>已抓取" + paged + "个页面");
						//判断任务状态
						if (!doc0_jq.find(".next ._button")[0] || paged == wantPageNum) { //如果没有下一页的按钮或者抓取完指定页面
							allowWork = true;
							paged = 0;
							$("#outputInfo").html($("#outputInfo").html() + "<br>页面抓取完成，开始获取图片网址");
							nowhtml = $("#outputInfo").html();
							if (allPageUrl.length < ajax1Bingfa) {
								ajax1Bingfa = allPageUrl.length;
							}
							for (var i = 0; i < ajax1Bingfa; i++) {
								setTimeout(ajaxfordoc1(allPageUrl[0]), i * ajax1Jiange);
							}
						} else {
							getpage();
						};
					}
				});
			}

			allowWork = false; //开始执行时更改许可状态
			getpage();
		}

		function output() {
			imgNum++;
			$(outputInfo).html(nowhtml + "<br>已获取" + imgNum + "张图片网址");
		}

		function ajaxfordoc1(url) {
			allPageUrl.shift();
			$.ajax({
				url: url,
				type: "get",
				async: true,
				cache: false,
				dataType: "text",
				success: function(data) {
					doc1 = parser.parseFromString(data, "text/html");
					doc1_jq = $(doc1);
					if (!!doc1_jq.find(".original-image")[0]) { //如果是单图
						imgUrlList[imgNum] = doc1_jq.find(".original-image").attr("data-src");
						imgTitle.push(doc1_jq.find(".work-info .title").text());
						addTagToArray();
						output();
					} else if (!!doc1_jq.find(".works_display")[0]) { //单图以外的情况
						if (!!$(doc1).find(".full-screen._ui-tooltip")[0]) { //如果是动图 DOMParser之后无法解析（找到）canvas标签，不然判断更简单
							imgUrlList[imgNum] = doc1_jq.find("#wrapper script").eq(0).text().split("\"src\":\"")[2].split("\",\"mime_type")[0].replace(/\\/g, ""); //DOMParser之后js不会执行，所以无法用p站自己的动图变量来获取动图网址了
							imgTitle.push(doc1_jq.find(".work-info .title").text());
							addTagToArray();
							output();
						} else {
							if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=manga") > -1) { //如果有mode=manga，是多图
								_allmanga.push(doc1_jq.find("link[rel='alternate']")[0].href.split("illust_id=")[1].split("&")[0]); //将多图作品的id追加到标识多图的数组里
								nowimgTitle = doc1_jq.find(".work-info .title").text();
								var pNum = Number(doc1_jq.find("ul.meta li").eq(1).text().split(" ")[1].split("P")[0]); //P数
								var thumbHref = doc1_jq.find(".works_display img").attr("src"); //缩略图url
								var bigImgHref = thumbHref.replace("600x600", "1200x1200"); //第一张大图的url
								var imgUrlSplit = bigImgHref.split("p0");
								for (var i = pNum - 1; i >= 0; i--) {
									imgUrlList[imgNum] = (imgUrlSplit[0] + "p" + i + imgUrlSplit[1]).replace("c/1200x1200/img-master", "img-original").replace("_master1200", "").replace("jpg", "png");
									imgTitle.push(nowimgTitle);
									addTagToArray();
									output();
								};
							} else if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=big") > -1) { //对于mode=big的情况，不再进行跳转
								_allmanga.push(doc1_jq.find(".works_display a").eq(0).attr("href").split("illust_id=")[1]);
								var trueurl = doc1_jq.find(".bookmark_modal_thumbnail").attr("data-src");
								trueurl = trueurl.replace("c/150x150/img-master", "img-original");
								trueurl = trueurl.replace("_master1200", "");
								imgUrlList[imgNum] = trueurl;
								imgTitle.push(doc1_jq.find(".work-info .title").text());
								addTagToArray();
								output();
							}
						}
					}
					if (maxGetNum > 0) {
						maxGetNum--;
					}
					if (allPageUrl.length > 0) { //如果存在下一个作品，则
						ajaxfordoc1(allPageUrl[0]);
					} else { //没有剩余作品
						ajax1No++;
						if (ajax1No === ajax1Bingfa) { //如果所有并发请求都执行完毕
							ok(loopNumIn);
							ajax1No = 0; //复位
						}
					}
				},
				statusCode: { //如果发生了错误则跳过该url
					0: function() {
						//ERR_CONNECTION_RESET
						ajaxfordoc1(allPageUrl[0]);
						console.log('请求的url不可访问');
					},
					400: function() {
						//400错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('该作品已被删除'); //在收藏的作品列表中，有些作品被作者删除了，却还显示有“编辑”按钮（有些是没有这个按钮的）。点击这个按钮会跳转到错误的“编辑收藏”页面，导致400错误。本状态码指示程序在这种情况下跳过。这个判断仅在下载书签作品的两部分js里添加。
					},
					403: function() {
						//403错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('无权访问请求的ur');
					},
					404: function() {
						//404错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('未找到该页面');
					}
				}
			});
		}


		//获取网址成功立即下载
		function ok(loopNumIn) {
			$(outputInfo).html($(outputInfo).html() + "<br>获取完毕，现在开始下载<br>");
			if (imgUrlList.length == 0) {
				$(outputInfo).html($(outputInfo).html() + ("<br>没有作品需要下载，本次任务已完成。<br><br>"));
				imgNum = 0;
				allowWork = true;
				alert("没有作品需要下载，本次任务已完成。");
			};
			var nowHtml = $(outputInfo).html();
			var reg = new RegExp(/'|#|&|\\|\/|:|\?|"|>|<|\*|\|/g); //将以下字符串替换为空格： ' # \ / : ? " < > * | 其中'会导致php创建文件时路径异常而失败，#则是不能用在url里，否则从#开始往后的字符都不会被当做是参数。剩下几个是windows中不允许做文件名的字符。至此困扰我好久的偶尔漏下图片的问题终于有眉目了
			if (window.location.href.indexOf("?id=") > -1) { //如果是在其他人的收藏页
				var artname = "bookmark_of_" + $(".user-link .user").text().replace(reg, " ");
			} else {
				var artname = "mybookmark";
			};
			var loopNum = loopNumIn;
			var length = imgUrlList.length; //这个变量用来对比验证批次请求是否全部完成
			var length2 = length; //这个变量用在每张图片下载成功之后，然后自减1
			var send = 0; //已成功获取的数量的
			var send2 = 0; //已发送的请求数量

			function fenpi(loopNum) {
				if (length2 < loopNum) { //url数量少于设置的请求数则发送url的实际数量
					loopNum = length2;
				};
				for (var i = 0; i < loopNum; i++) {
					var d = imgUrlList[0].split("/img/")[1].split("/"); //分割取出时间和文件名 ["2008", "06", "04", "23", "29", "25", "921663_p0.jpg"]
					var aid = d[6].split("_")[0]; //图片id
					var ismanga = 0;
					if (_allmanga.indexOf(aid) > -1) {
						ismanga = 1;
					}
					$.ajax({
						url: _phpPatch + "?url=" + encodeURI(imgUrlList[0] + "&aid=id" + aid + "&title=" + imgTitle[0].replace(reg, " ") + "&ismanga=" + ismanga + "&year=" + d[0] + "&month=" + d[1] + "&day=" + d[2] + "&h=" + d[3] + "&m=" + d[4] + "&s=" + d[5] + "&filename=" + d[6] + "&artname=" + artname + "&tag=" + tagArray[0].replace(reg, " ") + "&startUrl=" + startUrl),
						type: "get",
						async: true,
						cache: false,
						dataType: "text",
						success: function(data) {
							if (data !== "" && data.indexOf("fopen") > -1) { //php文件在成功时返回值是""。
								var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
								$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Warning：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
								nowHtml = $(outputInfo).html();
							}
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								imgNum = 0;
								allowWork = true;
								alert("下载完毕！");
							};
						},
						error: function() {
							var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
							$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Error：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
							nowHtml = $(outputInfo).html();
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								imgNum = 0;
								allowWork = true;
								alert("下载完毕！");
							};
						}
					});
					send2++;
					imgUrlList.shift();
					imgTitle.shift();
					tagArray.shift();
				}
			}

			fenpi(loopNum);
		}

		var outputInfo = document.createElement("div");
		outputInfo.id = "outputInfo";
		outputInfo.style.cssText = "background: #fff;padding: 10px;font-size: 14px;margin:6px auto;width:950px;";

		(function() {
			var downloadBotton = document.createElement("div");
			document.body.appendChild(downloadBotton);
			$(downloadBotton).text("下载书签中的作品");
			$(downloadBotton).attr("title", "下载书签中的作品，如有多页，默认会下载全部。")
			downloadBotton.style.cssText = "background: #00A514;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 335px;right: 0;z-index: 9999;cursor: pointer;";
			downloadBotton.addEventListener("click", function() {
				$("._global-header").eq(0).before(outputInfo);
				startGet();
			}, false);
		})();

		var notdown = "";
		(function() {
			var clearMultiple = document.createElement("div");
			clearMultiple.id = "clearMultiple";
			document.body.appendChild(clearMultiple);
			$(clearMultiple).text("排除指定类型的作品");
			$(clearMultiple).attr("title", "在下载前，您可以设置想要排除的作品类型。")
			clearMultiple.style.cssText = "background: #DA7002;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 385px;right: 0;z-index: 9999;cursor: pointer;";
			clearMultiple.addEventListener("click", function() {
				notdown = prompt("请设置下载时要排除的作品类型。如需多选，将多个数字连写即可\n1：排除多图\n2：排除动图\n3：排除单图", "");
				if (notdown === null) { //如果取消设置，则将返回值null改为字符串，不然无法使用indexOf
					notdown = "";
				};
			}, false);
		})();

	}()
} else if (window.location.href.indexOf("search.php?") > -1) { //5.on_tagsearch
	! function() {
		! function(a) {
			var b = a.prototype,
				c = b.parseFromString;
			try {
				if ((new a).parseFromString("", "text/html")) return
			} catch (d) {}
			b.parseFromString = function(a, b) {
				if (/^\s*text\/html\s*(?:;|$)/i.test(b)) {
					var d = document.implementation.createHTMLDocument("");
					return a.toLowerCase().indexOf("<!doctype") > -1 ? d.documentElement.innerHTML = a : d.body.innerHTML = a, d
				}
				return c.apply(this, arguments)
			}
		}(DOMParser);
		var parser = new DOMParser();

		var doc0;
		var baseUrl = window.location.href.split("&p=")[0] + "&p=";
		var startPageNo = Number($(".page-list .current").eq(0).text()); //最开始时的页码
		var allowWork = true; //如果本次抓取未完成，则不
		var paged = 0; //向下第几页
		var stop = false;
		var imgList = []; //储存所有作品
		var doneTip = ""; //在抓取完成时保存提示信息

		function output() {
			imgNum++;
			$(outputInfo).html(nowhtml + "<br>已获取" + imgNum + "张图片网址");
		}

		function changeResult() {
			$("#outputInfo").html(doneTip + "调整完毕，当前有" + $(".autopagerize_page_element .image-item:visible").length + "张作品。<br>");
		}

		function sortByProperty(propertyName) {
			return function(object1, object2) {
				var value1 = object1[propertyName];
				var value2 = object2[propertyName];
				if (value2 < value1) { //倒序排列
					return -1;
				} else if (value2 > value1) {
					return 1;
				} else {
					return 0;
				}
			}
		}

		function listSort() {
			doneTip = $("#outputInfo").html();
			imgList.sort(sortByProperty("num"));
			$(".autopagerize_page_element .image-item").remove();
			for (var i = 0; i < imgList.length; i++) {
				$(".autopagerize_page_element").append(imgList[i].e);
			}

			//处理tag列表页预览图的懒加载
			var img_thumbnail = document.querySelectorAll("._thumbnail");
			for (var i = 0; i < img_thumbnail.length; i++) {
				img_thumbnail[i].src = img_thumbnail[i].getAttribute("data-src");
			}
		}

		function startGet() {
			$(".user-ad-container.out").remove();
			if (!allowWork) {
				alert("当前任务尚未完成，请等到提示完成之后再设置新的任务。");
				return false;
			};
			var userset = prompt("请输入最低收藏数和要抓取的页数，用英文逗号分开。\n类似于下面的形式：\n1000,100", "1000,100");
			var wantFavNum = Number(userset.split(",")[0]);
			var wantPageNum = Number(userset.split(",")[1]);
			if (isNaN(wantFavNum) || wantFavNum <= 0 || isNaN(wantPageNum) || wantFavNum <= 0) {
				alert("参数不合法，请稍后重试。")
				return false;
			};
			$("#outputInfo").html($("#outputInfo").html() + "任务开始\n本次任务条件：收藏数不低于" + wantFavNum + "，向下抓取" + wantPageNum + "页");
			var pageed2 = 0; //本次已经抓取了多少页
			if (!paged) { //如果是首次抓取 则处理顶层窗口
				$(".popular-introduction").hide();
				$(".autopagerize_page_element .image-item").eq(5).css("height", "249px");
				var allPicArea = $(".autopagerize_page_element .image-item");
				for (var i = 0; i < allPicArea.length; i++) {
					var shoucang = allPicArea.eq(i).find("._ui-tooltip").eq(0).text();
					if (allPicArea.eq(i).find("._ui-tooltip").eq(0).text() < wantFavNum) { //必须限制序号0，不然对图片的回应数也会连起来
						allPicArea.eq(i).remove();
					} else {
						imgList.push({
							"e": allPicArea[i],
							"num": Number(shoucang)
						})
					};
				};
			}
			var nowhtml = $("#outputInfo").html();

			function getpage(url) {
				$.ajax({
					url: baseUrl + (startPageNo + 1 + paged),
					type: "get",
					async: true,
					cache: false,
					dataType: "text",
					success: function(data) {
						paged++;
						pageed2++;
						doc0 = parser.parseFromString(data, "text/html");
						var doc0_jq = $(doc0);
						var allPicArea = doc0_jq.find(".autopagerize_page_element").find(".image-item");
						for (var i = 0; i < allPicArea.length; i++) {
							var shoucang = allPicArea.eq(i).find("._ui-tooltip").eq(0).text();
							if (shoucang >= wantFavNum) {
								imgList.push({
									"e": allPicArea[i],
									"num": Number(shoucang)
								});
								$(window.top.document).find(".autopagerize_page_element")[0].appendChild(allPicArea[i]);
							};
						};
						$("#outputInfo").html(nowhtml + "<br>已抓取本次任务第" + pageed2 + "/" + wantPageNum + "页，当前加载到第" + (startPageNo + paged) + "页");
						//判断任务状态
						if (pageed2 == wantPageNum) {
							allowWork = true;
							$("#outputInfo").html($("#outputInfo").html() + "<br>本次任务完成。当前有" + $(".autopagerize_page_element .image-item").length + "张作品。<br><br>");
							// paged=0;         //不注释掉的话，每次添加筛选任务都是从当前页开始，而不是一直往后累计
							listSort();
							alert("本次任务已全部完成。");
							return false;
						} else if (!doc0_jq.find(".next ._button")[0]) {
							allowWork = true;
							$("#outputInfo").html($("#outputInfo").html() + "<br>已抓取本tag的所有页面，本次任务完成。当前有" + $(".autopagerize_page_element .image-item").length + "张作品。<br><br>");
							// paged=0;         //不注释掉的话，每次添加筛选任务都是从当前页开始，而不是一直往后累计
							listSort();
							alert("本次任务已全部完成。");
							return false;
						} else if (stop) {
							$("#outputInfo").html($("#outputInfo").html() + "<br>当前任务已中断！当前有" + $(".autopagerize_page_element .image-item").length + "张作品。<br><br>");
							stop = false;
							allowWork = true;
							alert("当前任务已中断！");
							listSort();
							return false;
						} else {
							getpage();
						};
					}
				});
			}

			allowWork = false; //开始执行时更改许可状态
			getpage();

		}

		var outputInfo = document.createElement("div");
		outputInfo.id = "outputInfo";
		outputInfo.style.cssText = "background: #fff;padding: 10px;font-size: 14px;margin:6px auto;width:950px;";

		(function() {
			var removeVip = document.createElement("div");
			document.body.appendChild(removeVip);
			$(removeVip).text("去除会员限制");
			$(removeVip).attr("title", "去掉中间区域热门作品上的会员限制。");
			removeVip.style.cssText = "background: #DA7002;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 185px;right: 0;z-index: 9999;cursor: pointer;";
			removeVip.addEventListener("click", function() {
				$(".popular-introduction a").eq(0).remove();
			}, false);
		})();

		(function() {
			var startBotton = document.createElement("div");
			document.body.appendChild(startBotton);
			$(startBotton).text("按收藏数筛选");
			startBotton.style.cssText = "background: #0096DB;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 235px;right: 0;z-index: 9999;cursor: pointer;";
			startBotton.addEventListener("click", function() {
				$("._global-header").eq(0).before(outputInfo);
				startGet();
			}, false);
		})();

		(function() {
			var stopFilter = document.createElement("div");
			document.body.appendChild(stopFilter);
			$(stopFilter).text("中断当前任务");
			$(stopFilter).attr("title", "筛选时中断之后可以继续执行。下载时中断，下次下载要重新获取图片网址。")
			stopFilter.style.cssText = "background: #DA7002;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 335px;right: 0;z-index: 9999;cursor: pointer;";
			stopFilter.addEventListener("click", function() {
				stop = true;
			}, false);
		})();

		(function() {
			var filterSelf = document.createElement("div");
			document.body.appendChild(filterSelf);
			$(filterSelf).text("在结果中筛选");
			$(filterSelf).attr("title", "如果本页筛选后作品太多，可以提高收藏数的要求，在结果中筛选。达不到要求的会被隐藏而不是删除。所以你可以反复进行筛选。被隐藏的项目不会被下载。")
			filterSelf.style.cssText = "background: #0096DB;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 385px;right: 0;z-index: 9999;cursor: pointer;";
			filterSelf.addEventListener("click", function() {
				var allPicArea = $(".autopagerize_page_element .image-item");
				var wantFavNum2 = prompt("将在当前作品列表中再次过滤，请输入要求的最低收藏数：", "1500");
				if (!wantFavNum2) {
					return false;
				} else if (isNaN(Number(wantFavNum2)) || ~~Number(wantFavNum2) <= 0) {
					alert("不合法的数值，取消本次操作。")
					return false;
				} else {
					wantFavNum2 = ~~Number(wantFavNum2);
				}
				for (var i = 0; i < allPicArea.length; i++) {
					if (allPicArea.eq(i).find("._ui-tooltip").eq(0).text() < wantFavNum2) { //必须限制序号0，不然对图片的回应数也会连起来
						allPicArea.eq(i).hide(); //这里把结果中不符合二次过滤隐藏掉，而非删除
					} else {
						allPicArea.eq(i).show();
					};
				};
				changeResult();
				// console.log("结果中筛选");
			}, false);
		})();

		(function() {
			var clearMultiple = document.createElement("div");
			document.body.appendChild(clearMultiple);
			$(clearMultiple).text("清除多图作品");
			$(clearMultiple).attr("title", "多图作品的图片质量以及与当前tag的相关度难以保证，并且会严重加大下载图片的数量。如不需要可以清除掉。")
			clearMultiple.style.cssText = "background: #DA7002;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 435px;right: 0;z-index: 9999;cursor: pointer;";
			clearMultiple.addEventListener("click", function() {
				var allPicArea = $(".autopagerize_page_element .image-item");
				for (var i = 0; i < allPicArea.length; i++) {
					if (!!allPicArea.eq(i).find(".multiple")[0]) {
						allPicArea.eq(i).remove();
					};
				};
				changeResult();
				// console.log("清除多图");
			}, false);
		})();

		(function() {
			var clearUgoku = document.createElement("div");
			document.body.appendChild(clearUgoku);
			$(clearUgoku).text("清除动图作品");
			$(clearUgoku).attr("title", "如不需要动图可以清除掉。")
			clearUgoku.style.cssText = "background: #DA7002;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 485px;right: 0;z-index: 9999;cursor: pointer;";
			clearUgoku.addEventListener("click", function() {
				var allPicArea = $(".autopagerize_page_element .image-item");
				for (var i = 0; i < allPicArea.length; i++) {
					if (!!allPicArea.eq(i).find(".ugoku-illust")[0]) {
						allPicArea.eq(i).remove();
					};
				};
				changeResult();
				// console.log("清除动图");
			}, false);
		})();

		(function() {
			var deleteBotton = document.createElement("div");
			deleteBotton.id = "deleteBotton";
			document.body.appendChild(deleteBotton);
			$(deleteBotton).text("手动删除作品");
			$(deleteBotton).attr("title", "可以在下载前手动删除不需要的作品。")
			$(deleteBotton).attr("data_del", "0")
			deleteBotton.style.cssText = "background: #DE0000;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 535px;right: 0;z-index: 9999;cursor: pointer;";
			$("#deleteBotton").bind("click", function() {
				$(".autopagerize_page_element .image-item").bind("click", function() {
					if ($("#deleteBotton").attr("data_del") === "1") {
						this.remove();
						if (allowWork) {
							changeResult();
							// console.log("手动删除");
						};
						return false;
					}
				});
				if ($("#deleteBotton").attr("data_del") === "0") {
					$("#deleteBotton").attr("data_del", "1")
					$("#deleteBotton").text("退出手动删除");
				} else if ($("#deleteBotton").attr("data_del") === "1") {
					$("#deleteBotton").attr("data_del", "0")
					$("#deleteBotton").text("手动删除作品");
				}
			});
		})();

		(function() {
			var clearBotton = document.createElement("div");
			document.body.appendChild(clearBotton);
			$(clearBotton).text("清空作品列表");
			$(clearBotton).attr("title", "如果网页内容过多，可能导致页面崩溃。如有需要可以清除当前的作品列表。")
			clearBotton.style.cssText = "background: #DE0000;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 585px;right: 0;z-index: 9999;cursor: pointer;";
			clearBotton.addEventListener("click", function() {
				$(".autopagerize_page_element .image-item").remove();
			}, false);
		})();

		// 以下是下载图片的代码——————————————————————————————————————————————

		(function() {
			var downloadBotton = document.createElement("div");
			document.body.appendChild(downloadBotton);
			$(downloadBotton).text("下载当前作品");
			$(downloadBotton).attr("title", "下载现在列表里的所有作品。")
			downloadBotton.style.cssText = "background: #00A514;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 285px;right: 0;z-index: 9999;cursor: pointer;";
			downloadBotton.addEventListener("click", function() {
				loopNumIn = prompt("最多允许同时下载多少张图片？\n如果动图特别多，建议设置为1或2", "10");
				if (loopNumIn === null || Number(loopNumIn) <= 0 || isNaN(Number(loopNumIn))) {
					alert("参数不正确！本次操作无效。");
					return false;
				} else {
					loopNumIn = ~~Number(loopNumIn);
				}
				getdownloadlist();
			}, false);
		})();

		var allPageUrl = [];

		function getdownloadlist() {
			if (!allowWork) {
				alert("当前筛选任务尚未完成，请等待完成后再下载。")
				return false;
			} else if ($(".autopagerize_page_element .image-item:visible").length == 0) {
				return false;
			};
			allowWork = false;
			var allList = $(".autopagerize_page_element .image-item:visible");
			for (var i = allList.length - 1; i >= 0; i--) {
				allPageUrl[i] = $(allList[i]).find("a").eq(0).attr("href");
			};
			$("._global-header").eq(0).before(outputInfo);
			$("#outputInfo").html($("#outputInfo").html() + "<br>当前列表中有" + allList.length + "张作品，开始获取作品信息");
			nowhtml = $("#outputInfo").html();
			if (allPageUrl.length < ajax1Bingfa) {
				ajax1Bingfa = allPageUrl.length;
			}
			for (var i = 0; i < ajax1Bingfa; i++) {
				setTimeout(ajaxfordoc1(allPageUrl[0]), i * ajax1Jiange);
			}
		}

		var doc1, nowimgTitle, nowhtml, loopNumIn;
		var imgNum = 0;
		var maxGetNum = -1; //限制的最大下载作品数，含当前作品页。需要限制的话改成数字，不需要则设置为【-1】，而不是0。注意一个作品里可能有多张图片、如有需要修改此数字
		var allPageUrl = [];
		var imgUrlList = [];
		var imgTitle = [];

		function ajaxfordoc1(url) {
			allPageUrl.shift();
			$.ajax({
				url: url,
				type: "get",
				async: true,
				cache: false,
				dataType: "text",
				success: function(data) {
					doc1 = parser.parseFromString(data, "text/html");
					doc1_jq = $(doc1);
					if (!!doc1_jq.find(".original-image")[0]) { //如果是单图
						imgUrlList[imgNum] = doc1_jq.find(".original-image").attr("data-src");
						imgTitle.push(doc1_jq.find(".work-info .title").text());
						addTagToArray();
						output();
					} else if (!!doc1_jq.find(".works_display")[0]) { //单图以外的情况
						if (!!$(doc1).find(".full-screen._ui-tooltip")[0]) { //如果是动图 DOMParser之后无法解析（找到）canvas标签，不然判断更简单
							imgUrlList[imgNum] = doc1_jq.find("#wrapper script").eq(0).text().split("\"src\":\"")[2].split("\",\"mime_type")[0].replace(/\\/g, ""); //DOMParser之后js不会执行，所以无法用p站自己的动图变量来获取动图网址了
							imgTitle.push(doc1_jq.find(".work-info .title").text());
							addTagToArray();
							output();
						} else {
							if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=manga") > -1) { //如果有mode=manga，是多图
								_allmanga.push(doc1_jq.find("link[rel='alternate']")[0].href.split("illust_id=")[1].split("&")[0]); //将多图作品的id追加到标识多图的数组里
								nowimgTitle = doc1_jq.find(".work-info .title").text();
								var pNum = Number(doc1_jq.find("ul.meta li").eq(1).text().split(" ")[1].split("P")[0]); //P数
								var thumbHref = doc1_jq.find(".works_display img").attr("src"); //缩略图url
								var bigImgHref = thumbHref.replace("600x600", "1200x1200"); //第一张大图的url
								var imgUrlSplit = bigImgHref.split("p0");
								for (var i = pNum - 1; i >= 0; i--) {
									imgUrlList[imgNum] = (imgUrlSplit[0] + "p" + i + imgUrlSplit[1]).replace("c/1200x1200/img-master", "img-original").replace("_master1200", "").replace("jpg", "png");
									imgTitle.push(nowimgTitle);
									addTagToArray();
									output();
								};
							} else if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=big") > -1) { //对于mode=big的情况，不再进行跳转
								_allmanga.push(doc1_jq.find(".works_display a").eq(0).attr("href").split("illust_id=")[1]);
								var trueurl = doc1_jq.find(".bookmark_modal_thumbnail").attr("data-src");
								trueurl = trueurl.replace("c/150x150/img-master", "img-original");
								trueurl = trueurl.replace("_master1200", "");
								imgUrlList[imgNum] = trueurl;
								imgTitle.push(doc1_jq.find(".work-info .title").text());
								addTagToArray();
								output();
							}
						}
					}
					if (maxGetNum > 0) {
						maxGetNum--;
					}
					if (stop) {
						stop = false;
						allowWork = true;
						imgNum = 0;
						imgUrlList = [];
						imgTitle = [];
						$("#outputInfo").html($("#outputInfo").html() + "<br>当前任务已中断！<br><br>");
						alert("当前任务已中断！");
						return false;
					}
					if (allPageUrl.length > 0) { //如果存在下一个作品，则
						ajaxfordoc1(allPageUrl[0]);
					} else { //没有剩余作品
						ajax1No++;
						if (ajax1No === ajax1Bingfa) { //如果所有请求都执行完毕
							ok(loopNumIn);
							ajax1No = 0; //复位
						}
					}
				},
				statusCode: { //如果发生了错误则跳过该url
					0: function() {
						//ERR_CONNECTION_RESET
						ajaxfordoc1(allPageUrl[0]);
						console.log('请求的url不可访问');
					},
					403: function() {
						//403错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('无权访问请求的ur');
					},
					404: function() {
						//404错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('未找到该页面');
					}
				}
			});
		}


		//获取网址成功立即下载
		function ok(loopNumIn) {
			$(outputInfo).html($(outputInfo).html() + "<br>获取完毕，现在开始下载<br>");
			var nowHtml = $(outputInfo).html();
			var reg = new RegExp(/'|#|&|\\|\/|:|\?|"|>|<|\*|\|/g); //将以下字符串替换为空格： ' # \ / : ? " < > * | 其中'会导致php创建文件时路径异常而失败，#则是不能用在url里，否则从#开始往后的字符都不会被当做是参数。剩下几个是windows中不允许做文件名的字符。至此困扰我好久的偶尔漏下图片的问题终于有眉目了
			var artname = $(".self").text().replace(reg, " "); //画师id和名字，形如 id=1313987_梅  【注意】这里是把原来的代码改造为下载搜索tag页面的图片，所以这里的画师名实际上是tag的名字
			var loopNum = loopNumIn;
			var length = imgUrlList.length; //这个变量用来对比验证批次请求是否全部完成
			var length2 = length; //这个变量用在每张图片下载成功之后，然后自减1
			var send = 0; //已成功获取的数量的
			var send2 = 0; //已发送的请求数量

			function fenpi(loopNum) {
				if (stop) {
					stop = false;
					allowWork = true;
					imgNum = 0;
					imgUrlList = [];
					imgTitle = [];
					$("#outputInfo").html($("#outputInfo").html() + "<br>当前任务已中断！<br><br>");
					alert("当前任务已中断！");
					return false;
				}
				if (length2 < loopNum) { //url数量少于设置的请求数则发送url的实际数量
					loopNum = length2;
				};
				for (var i = 0; i < loopNum; i++) {
					var d = imgUrlList[0].split("/img/")[1].split("/"); //分割取出时间和文件名 ["2008", "06", "04", "23", "29", "25", "921663_p0.jpg"]
					var aid = d[6].split("_")[0]; //图片id
					var ismanga = 0;
					if (_allmanga.indexOf(aid) > -1) {
						ismanga = 1;
					}
					$.ajax({
						url: _phpPatch + "?url=" + encodeURI(imgUrlList[0] + "&aid=id" + aid + "&title=" + imgTitle[0].replace(reg, " ") + "&ismanga=" + ismanga + "&year=" + d[0] + "&month=" + d[1] + "&day=" + d[2] + "&h=" + d[3] + "&m=" + d[4] + "&s=" + d[5] + "&filename=" + d[6] + "&artname=tag_" + artname + "&tag=" + tagArray[0].replace(reg, " ") + "&startUrl=" + startUrl),
						type: "get",
						async: true,
						cache: false,
						dataType: "text",
						success: function(data) {
							console.log(data)
							if (data !== "" && data.indexOf("fopen") > -1) { //php文件在成功时返回值是""。
								var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
								$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Warning：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
								nowHtml = $(outputInfo).html();
							}
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								allowWork = true;
								imgNum = 0;
								alert("下载完毕！");
							};
						},
						error: function() {
							var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
							$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Error：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
							nowHtml = $(outputInfo).html();
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								allowWork = true;
								imgNum = 0;
								alert("下载完毕！");
							};
						}
					});
					send2++;
					imgUrlList.shift();
					imgTitle.shift();
					tagArray.shift();
				}
			}

			fenpi(loopNum);
		}

		window.onbeforeunload = function() {
			if (!allowWork) {
				if (!window.confirm("本页面有进行中的任务，确定关闭本页面吗？")) {
					return false;
				};
			}
		}
	}()
} else if (window.location.href.indexOf("ranking_area.php") > -1 && window.location.href !== "https://www.pixiv.net/ranking_area.php") { //6.on_ranking_area
	! function() {
		! function(a) {
			var b = a.prototype,
				c = b.parseFromString;
			try {
				if ((new a).parseFromString("", "text/html")) return
			} catch (d) {}
			b.parseFromString = function(a, b) {
				if (/^\s*text\/html\s*(?:;|$)/i.test(b)) {
					var d = document.implementation.createHTMLDocument("");
					return a.toLowerCase().indexOf("<!doctype") > -1 ? d.documentElement.innerHTML = a : d.body.innerHTML = a, d
				}
				return c.apply(this, arguments)
			}
		}(DOMParser);
		var parser = new DOMParser();

		var outputInfo = document.createElement("div");
		outputInfo.id = "outputInfo";
		outputInfo.style.cssText = "background: #fff;padding: 10px;font-size: 14px;margin:6px auto;width:950px;";

		function output() {
			imgNum++;
			$(outputInfo).html(nowhtml + "<br>已获取" + imgNum + "张图片网址");
		}

		(function() {
			var downloadBotton = document.createElement("div");
			document.body.appendChild(downloadBotton);
			$(downloadBotton).text("下载本页作品");
			$(downloadBotton).attr("title", "下载本页列表中的所有作品，共100个作品。")
			downloadBotton.style.cssText = "background: #00A514;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 285px;right: 0;z-index: 9999;cursor: pointer;";
			downloadBotton.addEventListener("click", function() {
				loopNumIn = prompt("最多允许同时下载多少张图片？\n如果动图特别多，建议设置为1或2", "10");
				if (loopNumIn === null || Number(loopNumIn) <= 0 || isNaN(Number(loopNumIn))) {
					alert("参数不正确！本次操作无效。");
					return false;
				} else {
					loopNumIn = ~~Number(loopNumIn);
				}
				getdownloadlist();
			}, false);
		})();

		(function() {
			var clearMultiple = document.createElement("div");
			document.body.appendChild(clearMultiple);
			$(clearMultiple).text("清除多图作品");
			$(clearMultiple).attr("title", "如果不想下载多图作品可以清除掉。")
			clearMultiple.style.cssText = "background: #DA7002;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 335px;right: 0;z-index: 9999;cursor: pointer;";
			clearMultiple.addEventListener("click", function() {
				var allPicArea = $(".ranking-item");
				for (var i = 0; i < allPicArea.length; i++) {
					if (allPicArea.eq(i).find("a").eq(1).attr("class").indexOf("multiple") > -1 || allPicArea.eq(i).find("a").eq(1).attr("class").indexOf("manga") > -1) {
						allPicArea.eq(i).remove();
					};
				};
			}, false);
		})();

		var allowWork = true; //如果本次抓取未完成，则不
		var allPageUrl = [];

		function getdownloadlist() {
			if (!allowWork) {
				alert("当前任务尚未完成，请等待完成后再下载。")
				return false;
			};
			allowWork = false;
			var allList = $(".ranking-item");
			for (var i = allList.length - 1; i >= 0; i--) {
				allPageUrl[i] = $(".ranking-item").eq(i).find("a").eq(1).attr("href");
			};
			$("._global-header").eq(0).before(outputInfo);
			$("#outputInfo").html("当前列表中有" + allList.length + "张作品，开始获取作品信息");
			nowhtml = $("#outputInfo").html();
			if (allPageUrl.length < ajax1Bingfa) {
				ajax1Bingfa = allPageUrl.length;
			}
			for (var i = 0; i < ajax1Bingfa; i++) {
				setTimeout(ajaxfordoc1(allPageUrl[0]), i * ajax1Jiange);
			}
		}

		var doc1, nowimgTitle, nowhtml, loopNumIn;
		var imgNum = 0;
		var maxGetNum = -1; //限制的最大下载作品数，含当前作品页。需要限制的话改成数字，不需要则设置为【-1】，而不是0。注意一个作品里可能有多张图片、如有需要修改此数字
		var allPageUrl = [];
		var imgUrlList = [];
		var imgTitle = [];

		function ajaxfordoc1(url) {
			allPageUrl.shift();
			$.ajax({
				url: url,
				type: "get",
				async: true,
				cache: false,
				dataType: "text",
				success: function(data) {
					doc1 = parser.parseFromString(data, "text/html");
					doc1_jq = $(doc1);
					if (!!doc1_jq.find(".original-image")[0]) { //如果是单图
						imgUrlList[imgNum] = doc1_jq.find(".original-image").attr("data-src");
						imgTitle.push(doc1_jq.find(".work-info .title").text());
						addTagToArray();
						output();
					} else if (!!doc1_jq.find(".works_display")[0]) { //单图以外的情况
						if (!!$(doc1).find(".full-screen._ui-tooltip")[0]) { //如果是动图 DOMParser之后无法解析（找到）canvas标签，不然判断更简单
							imgUrlList[imgNum] = doc1_jq.find("#wrapper script").eq(0).text().split("\"src\":\"")[2].split("\",\"mime_type")[0].replace(/\\/g, ""); //DOMParser之后js不会执行，所以无法用p站自己的动图变量来获取动图网址了
							imgTitle.push(doc1_jq.find(".work-info .title").text());
							addTagToArray();
							output();
						} else {
							if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=manga") > -1) { //如果有mode=manga，是多图
								_allmanga.push(doc1_jq.find("link[rel='alternate']")[0].href.split("illust_id=")[1].split("&")[0]); //将多图作品的id追加到标识多图的数组里
								nowimgTitle = doc1_jq.find(".work-info .title").text();
								var pNum = Number(doc1_jq.find("ul.meta li").eq(1).text().split(" ")[1].split("P")[0]); //P数
								var thumbHref = doc1_jq.find(".works_display img").attr("src"); //缩略图url
								var bigImgHref = thumbHref.replace("600x600", "1200x1200"); //第一张大图的url
								var imgUrlSplit = bigImgHref.split("p0");
								for (var i = pNum - 1; i >= 0; i--) {
									imgUrlList[imgNum] = (imgUrlSplit[0] + "p" + i + imgUrlSplit[1]).replace("c/1200x1200/img-master", "img-original").replace("_master1200", "").replace("jpg", "png");
									imgTitle.push(nowimgTitle);
									addTagToArray();
									output();
								};
							} else if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=big") > -1) { //对于mode=big的情况，不再进行跳转
								_allmanga.push(doc1_jq.find(".works_display a").eq(0).attr("href").split("illust_id=")[1]);
								var trueurl = doc1_jq.find(".bookmark_modal_thumbnail").attr("data-src");
								trueurl = trueurl.replace("c/150x150/img-master", "img-original");
								trueurl = trueurl.replace("_master1200", "");
								imgUrlList[imgNum] = trueurl;
								imgTitle.push(doc1_jq.find(".work-info .title").text());
								addTagToArray();
								output();
							}
						}
					}
					if (maxGetNum > 0) {
						maxGetNum--;
					}
					if (allPageUrl.length > 0) { //如果存在下一个作品，则
						ajaxfordoc1(allPageUrl[0]);
					} else { //没有剩余作品
						ajax1No++;
						if (ajax1No === ajax1Bingfa) { //如果所有请求都执行完毕
							ok(loopNumIn);
							ajax1No = 0; //复位
						}
					}
				},
				statusCode: { //如果发生了错误则跳过该url
					0: function() {
						//ERR_CONNECTION_RESET
						ajaxfordoc1(allPageUrl[0]);
						console.log('请求的url不可访问');
					},
					403: function() {
						//403错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('无权访问请求的ur');
					},
					404: function() {
						//404错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('未找到该页面');
					}
				}
			});
		}


		//获取网址成功立即下载
		function ok(loopNumIn) {
			$(outputInfo).html($(outputInfo).html() + "<br>获取完毕，现在开始下载<br>");
			var nowHtml = $(outputInfo).html();
			var reg = new RegExp(/'|#|&|\\|\/|:|\?|"|>|<|\*|\|/g); //将以下字符串替换为空格： ' # \ / : ? " < > * | 其中'会导致php创建文件时路径异常而失败，#则是不能用在url里，否则从#开始往后的字符都不会被当做是参数。剩下几个是windows中不允许做文件名的字符。至此困扰我好久的偶尔漏下图片的问题终于有眉目了
			var artname = $(".self").text().replace(reg, " "); //画师id和名字，形如 id=1313987_梅  【注意】这里是把原来的代码改造为下载搜索tag页面的图片，所以这里的画师名实际上是tag的名字
			var loopNum = loopNumIn;
			var length = imgUrlList.length; //这个变量用来对比验证批次请求是否全部完成
			var length2 = length; //这个变量用在每张图片下载成功之后，然后自减1
			var send = 0; //已成功获取的数量的
			var send2 = 0; //已发送的请求数量

			function fenpi(loopNum) {
				if (length2 < loopNum) { //url数量少于设置的请求数则发送url的实际数量
					loopNum = length2;
				};
				for (var i = 0; i < loopNum; i++) {
					var d = imgUrlList[0].split("/img/")[1].split("/"); //分割取出时间和文件名 ["2008", "06", "04", "23", "29", "25", "921663_p0.jpg"]
					var aid = d[6].split("_")[0]; //图片id
					var ismanga = 0;
					if (_allmanga.indexOf(aid) > -1) {
						ismanga = 1;
					}
					$.ajax({
						url: _phpPatch + "?url=" + encodeURI(imgUrlList[0] + "&aid=id" + aid + "&title=" + imgTitle[0].replace(reg, " ") + "&ismanga=" + ismanga + "&year=" + d[0] + "&month=" + d[1] + "&day=" + d[2] + "&h=" + d[3] + "&m=" + d[4] + "&s=" + d[5] + "&filename=" + d[6] + "&artname=地区排行榜_" + artname + "_" + $("._about").text().replace(reg, "_") + "&tag=" + tagArray[0].replace(reg, " ") + "&startUrl=" + startUrl),
						type: "get",
						async: true,
						cache: false,
						dataType: "text",
						success: function(data) {
							if (data !== "" && data.indexOf("fopen") > -1) { //php文件在成功时返回值是""。
								var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
								$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Warning：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
								nowHtml = $(outputInfo).html();
							}
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								allowWork = true;
								imgNum = 0;
								alert("下载完毕！");
							};
						},
						error: function() {
							var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
							$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Error：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
							nowHtml = $(outputInfo).html();
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								allowWork = true;
								imgNum = 0;
								alert("下载完毕！");
							};
						}
					});
					send2++;
					imgUrlList.shift();
					imgTitle.shift();
					tagArray.shift();
				}
			}

			fenpi(loopNum);
		}

		window.onbeforeunload = function() {
			if (!allowWork) {
				if (!window.confirm("本页面有进行中的任务，确定关闭本页面吗？")) {
					return false;
				};
			}
		}
	}()
} else if (window.location.href.indexOf("ranking.php") > -1) { //7.on_ranking_else
	! function() {
		! function(a) {
			var b = a.prototype,
				c = b.parseFromString;
			try {
				if ((new a).parseFromString("", "text/html")) return
			} catch (d) {}
			b.parseFromString = function(a, b) {
				if (/^\s*text\/html\s*(?:;|$)/i.test(b)) {
					var d = document.implementation.createHTMLDocument("");
					return a.toLowerCase().indexOf("<!doctype") > -1 ? d.documentElement.innerHTML = a : d.body.innerHTML = a, d
				}
				return c.apply(this, arguments)
			}
		}(DOMParser);
		var parser = new DOMParser();

		var doc0, nowhtml;
		if (window.location.href !== "https://www.pixiv.net/ranking.php") {
			var baseUrl = window.location.href + "&p=";
		} else {
			var baseUrl = window.location.href + "?p=";
		}
		var allowWork = true; //如果本次抓取未完成，则不
		var paged = 0; //向下第几页
		var not_down_duotu = false; //不下载多图作品
		var allPageUrl = [];

		if ((baseUrl.indexOf("mode=daily") > -1 || baseUrl.indexOf("mode=weekly") > -1) && baseUrl.indexOf("r18") == -1) {
			var maxpage = 10; //排行榜页面一开始有50张作品，如果页面到了底部，会再向下加载，现在已知每日排行榜是10部分，日榜的r18是2部分，其他是6部分。为防止有未考虑到的情况出现，所以在此部分的getpage函数里判断了404状态码。
		} else if ((baseUrl.indexOf("mode=daily") > -1 || baseUrl.indexOf("mode=weekly") > -1) && baseUrl.indexOf("r18") > -1) {
			var maxpage = 2;
		} else if (baseUrl.indexOf("r18g") > -1) {
			var maxpage = 1;
		} else {
			var maxpage = 6;
		}

		function output() {
			imgNum++;
			$(outputInfo).html(nowhtml + "<br>已获取" + imgNum + "张图片网址");
		}

		function startGet() {
			if (!allowWork) {
				alert("当前任务尚未完成，请等到提示完成之后再设置新的任务。");
				return false;
			};
			if (!$("#outputInfo")[0]) {
				$("._global-header").eq(0).before(outputInfo);
			};
			if (not_down_duotu) {
				$("#outputInfo").html("任务开始，本次任务排除多图作品");
			} else {
				$("#outputInfo").html("任务开始，本次任务下载全部作品");
			}
			nowhtml = $("#outputInfo").html();

			function getpage(url) {
				$.ajax({
					url: baseUrl + (1 + paged),
					type: "get",
					async: true,
					cache: false,
					dataType: "text",
					success: function(data) {
						paged++;
						doc0 = parser.parseFromString(data, "text/html");
						var doc0_jq = $(doc0);
						var allPicArea = doc0_jq.find(".ranking-item");
						if (not_down_duotu) {
							for (var i = 0; i < allPicArea.length; i++) {
								if (!allPicArea.eq(i).find("a")[0]) { //如果列表中的这个作品没有a标签，则是被删除、或非公开等错误项
									continue;
								};
								if (allPicArea.eq(i).find(".ranking-image-item a").attr("class").indexOf("multiple") == -1 && allPicArea.eq(i).find(".ranking-image-item a").attr("class").indexOf("manga") == -1) {
									allPageUrl.push(allPicArea.eq(i).find(".ranking-image-item a").attr("href"));
								}
							};
						} else {
							for (var i = 0; i < allPicArea.length; i++) {
								allPageUrl.push(allPicArea.eq(i).find(".ranking-image-item a").attr("href"));
							};
						}
						$("#outputInfo").html(nowhtml + "<br>已抓取本页面第" + paged + "部分");
						if (paged == maxpage) {
							$("#outputInfo").html($("#outputInfo").html() + "<br>本页面抓取完成。当前有" + allPageUrl.length + "张作品，开始获取作品信息。<br><br>");
							nowhtml = $("#outputInfo").html();
							if (allPageUrl.length < ajax1Bingfa) {
								ajax1Bingfa = allPageUrl.length;
							}
							for (var i = 0; i < ajax1Bingfa; i++) {
								setTimeout(ajaxfordoc1(allPageUrl[0]), i * ajax1Jiange);
							}
						} else {
							getpage();
						};
					},
					statusCode: {
						404: function() { //如果发生了404错误，则中断抓取，直接下载已有部分。（因为可能确实没有下一部分了，只是这种情况我们没见到，那么现有的判断可能就不适用。
							console.log("404错误，直接下载已有部分");
							$("#outputInfo").html($("#outputInfo").html() + "<br>本页面抓取完成。当前有" + allPageUrl.length + "张作品，开始获取作品信息。<br><br>");
							nowhtml = $("#outputInfo").html();
							ajaxfordoc1(allPageUrl[0]);
						}
					}
				});
			}

			allowWork = false; //开始执行时更改许可状态
			getpage();

		}

		var outputInfo = document.createElement("div");
		outputInfo.id = "outputInfo";
		outputInfo.style.cssText = "background: #fff;padding: 10px;font-size: 14px;margin:6px auto;width:950px;";


		(function() {
			var downloadBotton = document.createElement("div");
			document.body.appendChild(downloadBotton);
			$(downloadBotton).text("下载本排行榜作品");
			$(downloadBotton).attr("title", "下载本排行榜的所有作品，包括未加载出来的。")
			downloadBotton.style.cssText = "background: #00A514;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 285px;right: 0;z-index: 9999;cursor: pointer;";
			downloadBotton.addEventListener("click", function() {
				loopNumIn = prompt("最多允许同时下载多少张图片？\n如果动图特别多，建议设置为1或2", "10");
				if (loopNumIn === null || Number(loopNumIn) <= 0 || isNaN(Number(loopNumIn))) {
					alert("参数不正确！本次操作无效。");
					return false;
				} else {
					loopNumIn = ~~Number(loopNumIn);
				}
				startGet();
			}, false);
		})();

		(function() {
			var clearMultiple = document.createElement("div");
			clearMultiple.id = "clearMultiple";
			document.body.appendChild(clearMultiple);
			$(clearMultiple).text("点击排除多图作品");
			$(clearMultiple).attr("title", "如不需要多图作品可以清除掉。")
			clearMultiple.style.cssText = "background: #DA7002;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 335px;right: 0;z-index: 9999;cursor: pointer;";
			clearMultiple.addEventListener("click", function() {
				if (!not_down_duotu) {
					not_down_duotu = true;
					alert("设置成功，将不会下载多图作品。");
					$("#clearMultiple").text("再次点击取消排除");
				} else {
					not_down_duotu = false;
					alert("取消成功，不再排除多图作品。");
					$("#clearMultiple").text("点击排除多图作品");
				}

			}, false);
		})();

		var doc1, nowimgTitle, loopNumIn;
		var imgNum = 0;
		var maxGetNum = -1; //限制的最大下载作品数，含当前作品页。需要限制的话改成数字，不需要则设置为【-1】，而不是0。注意一个作品里可能有多张图片、如有需要修改此数字
		var allPageUrl = [];
		var imgUrlList = [];
		var imgTitle = [];

		function ajaxfordoc1(url) {
			allPageUrl.shift();
			$.ajax({
				url: url,
				type: "get",
				async: true,
				cache: false,
				dataType: "text",
				success: function(data) {
					doc1 = parser.parseFromString(data, "text/html");
					doc1_jq = $(doc1);
					if (!!doc1_jq.find(".original-image")[0]) { //如果是单图
						imgUrlList[imgNum] = doc1_jq.find(".original-image").attr("data-src");
						imgTitle.push(doc1_jq.find(".work-info .title").text());
						addTagToArray();
						output();
					} else if (!!doc1_jq.find(".works_display")[0]) { //单图以外的情况
						if (!!$(doc1).find(".full-screen._ui-tooltip")[0]) { //如果是动图 DOMParser之后无法解析（找到）canvas标签，不然判断更简单
							imgUrlList[imgNum] = doc1_jq.find("#wrapper script").eq(0).text().split("\"src\":\"")[2].split("\",\"mime_type")[0].replace(/\\/g, ""); //DOMParser之后js不会执行，所以无法用p站自己的动图变量来获取动图网址了
							imgTitle.push(doc1_jq.find(".work-info .title").text());
							addTagToArray();
							output();
						} else {
							if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=manga") > -1) { //如果有mode=manga，是多图
								_allmanga.push(doc1_jq.find("link[rel='alternate']")[0].href.split("illust_id=")[1].split("&")[0]); //将多图作品的id追加到标识多图的数组里
								nowimgTitle = doc1_jq.find(".work-info .title").text();
								var pNum = Number(doc1_jq.find("ul.meta li").eq(1).text().split(" ")[1].split("P")[0]); //P数
								var thumbHref = doc1_jq.find(".works_display img").attr("src"); //缩略图url
								var bigImgHref = thumbHref.replace("600x600", "1200x1200"); //第一张大图的url
								var imgUrlSplit = bigImgHref.split("p0");
								for (var i = pNum - 1; i >= 0; i--) {
									imgUrlList[imgNum] = (imgUrlSplit[0] + "p" + i + imgUrlSplit[1]).replace("c/1200x1200/img-master", "img-original").replace("_master1200", "").replace("jpg", "png");
									imgTitle.push(nowimgTitle);
									addTagToArray();
									output();
								};
							} else if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=big") > -1) { //对于mode=big的情况，不再进行跳转
								_allmanga.push(doc1_jq.find(".works_display a").eq(0).attr("href").split("illust_id=")[1]);
								var trueurl = doc1_jq.find(".bookmark_modal_thumbnail").attr("data-src");
								trueurl = trueurl.replace("c/150x150/img-master", "img-original");
								trueurl = trueurl.replace("_master1200", "");
								imgUrlList[imgNum] = trueurl;
								imgTitle.push(doc1_jq.find(".work-info .title").text());
								addTagToArray();
								output();
							}
						}
					}
					if (maxGetNum > 0) {
						maxGetNum--;
					}
					if (allPageUrl.length > 0) { //如果存在下一个作品，则
						ajaxfordoc1(allPageUrl[0]);
					} else { //没有剩余作品
						ajax1No++;
						if (ajax1No === ajax1Bingfa) { //如果所有请求都执行完毕
							ok(loopNumIn);
							ajax1No = 0; //复位
						}
					}
				},
				statusCode: { //如果发生了错误则跳过该url
					0: function() {
						//ERR_CONNECTION_RESET
						ajaxfordoc1(allPageUrl[0]);
						console.log('请求的url不可访问');
					},
					403: function() {
						//403错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('无权访问请求的ur');
					},
					404: function() {
						//404错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('未找到该页面');
					}
				}
			});
		}


		//获取网址成功立即下载
		function ok(loopNumIn) {
			$(outputInfo).html($(outputInfo).html() + "<br>获取完毕，现在开始下载<br>");
			var nowHtml = $(outputInfo).html();
			var reg = new RegExp(/'|#|&|\\|\/|:|\?|"|>|<|\*|\|/g); //将以下字符串替换为空格： ' # \ / : ? " < > * | 其中'会导致php创建文件时路径异常而失败，#则是不能用在url里，否则从#开始往后的字符都不会被当做是参数。剩下几个是windows中不允许做文件名的字符。至此困扰我好久的偶尔漏下图片的问题终于有眉目了
			var artname = $(".self").text().replace(reg, " "); //画师id和名字，形如 id=1313987_梅  【注意】这里是把原来的代码改造为下载搜索tag页面的图片，所以这里的画师名实际上是tag的名字
			var loopNum = loopNumIn;
			var length = imgUrlList.length; //这个变量用来对比验证批次请求是否全部完成
			var length2 = length; //这个变量用在每张图片下载成功之后，然后自减1
			var send = 0; //已成功获取的数量的
			var send2 = 0; //已发送的请求数量

			function fenpi(loopNum) {
				if (length2 < loopNum) { //url数量少于设置的请求数则发送url的实际数量
					loopNum = length2;
				};
				for (var i = 0; i < loopNum; i++) {
					var d = imgUrlList[0].split("/img/")[1].split("/"); //分割取出时间和文件名 ["2008", "06", "04", "23", "29", "25", "921663_p0.jpg"]
					var aid = d[6].split("_")[0]; //图片id
					var ismanga = 0;
					if (_allmanga.indexOf(aid) > -1) {
						ismanga = 1;
					}
					$.ajax({
						url: _phpPatch + "?url=" + encodeURI(imgUrlList[0] + "&aid=id" + aid + "&title=" + imgTitle[0].replace(reg, " ") + "&ismanga=" + ismanga + "&year=" + d[0] + "&month=" + d[1] + "&day=" + d[2] + "&h=" + d[3] + "&m=" + d[4] + "&s=" + d[5] + "&filename=" + d[6] + "&artname=排行榜_" + artname + "_" + $(".sibling-items a.current").eq(0).text().replace(reg, "_") + "&tag=" + tagArray[0].replace(reg, " ") + "&startUrl=" + startUrl),
						type: "get",
						async: true,
						cache: false,
						dataType: "text",
						success: function(data) {
							if (data !== "" && data.indexOf("fopen") > -1) { //php文件在成功时返回值是""。
								var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
								$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Warning：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
								nowHtml = $(outputInfo).html();
							}
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								allowWork = true;
								imgNum = 0;
								alert("下载完毕！");
							};
						},
						error: function() {
							var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
							$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Error：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
							nowHtml = $(outputInfo).html();
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								allowWork = true;
								imgNum = 0;
								alert("下载完毕！");
							};
						}
					});
					send2++;
					imgUrlList.shift();
					imgTitle.shift();
					tagArray.shift();
				}
			}

			fenpi(loopNum);
		}

		window.onbeforeunload = function() {
			if (!allowWork) {
				if (!window.confirm("本页面有进行中的任务，确定关闭本页面吗？")) {
					return false;
				};
			}
		}
	}()
}
/*
 else if (window.location.href.indexOf("https://www.pixivision.net/zh/a/") > -1) { //8.on_特辑
	! function() {
		! function(a) {
			var b = a.prototype,
				c = b.parseFromString;
			try {
				if ((new a).parseFromString("", "text/html")) return
			} catch (d) {}
			b.parseFromString = function(a, b) {
				if (/^\s*text\/html\s*(?:;|$)/i.test(b)) {
					var d = document.implementation.createHTMLDocument("");
					return a.toLowerCase().indexOf("<!doctype") > -1 ? d.documentElement.innerHTML = a : d.body.innerHTML = a, d
				}
				return c.apply(this, arguments)
			}
		}(DOMParser);
		var parser = new DOMParser();

		var doc0, doc1, nowimgTitle, nowhtml, loopNumIn;
		var allowWork = true; //如果本次抓取未完成，则不
		var paged = 0; //向下第几页
		var imgNum = 0;
		var allPageUrl = [];
		var imgUrlList = [];
		var imgTitle = [];
		var baseUrl = window.location.href;

		function startGet() {
			if (!allowWork) {
				alert("当前任务尚未完成，请等到提示完成之后再设置新的任务。");
				return false;
			};
			loopNumIn = prompt("最多允许同时下载多少张图片？\n如果动图特别多，建议设置为1或2", "10");
			if (loopNumIn === null || Number(loopNumIn) <= 0 || isNaN(Number(loopNumIn))) {
				alert("参数不正确！本次操作无效。");
				return false;
			} else {
				loopNumIn = ~~Number(loopNumIn);
			}

			var allLink = $(".am__work");
			for (var i = 0; i < allLink.length; i++) {
				allPageUrl.push(allLink.eq(i).find("a").eq(1).attr("href"));
				$(outputInfo).html("已获取" + allPageUrl.length + "个页面网址"); //添加页面中的图片
			}
			allPageUrl.push($("a[data-gtm-action='ClickIllust']").attr("href")); //添加首屏大图
			$(outputInfo).html("已获取" + allPageUrl.length + "个页面网址"); //添加页面中的图片

			if (allPageUrl.length < ajax1Bingfa) {
				ajax1Bingfa = allPageUrl.length;
			}
			for (var i = 0; i < ajax1Bingfa; i++) {
				setTimeout(ajaxfordoc1(allPageUrl[0]), i * ajax1Jiange);
			}
			nowhtml = $("#outputInfo").html();
		}

		function output() {
			imgNum++;
			$(outputInfo).html(nowhtml + "<br>已获取" + imgNum + "张图片网址");
		}

		function ajaxfordoc1(url) {
			allPageUrl.shift();
			$.ajax({
				url: crossP_Path + "?url=" + encodeURIComponent(url),
				type: "get",
				async: true,
				cache: false,
				dataType: "text",
				success: function(data) {
					if (data === "false") {
						alert("程序出错，获取不到页面。请联系作者。\n程序已停止执行。");
						return false;
					}
					doc1 = parser.parseFromString(data, "text/html");
					doc1_jq = $(doc1);
					if (!!doc1_jq.find("newindex-signup")[0]) {
						alert("cookie已失效，因此无法下载专辑作品。程序已停止执行;如有需要请联系作者。\n如果想使用自己的cookie（这样你就可以自行修复了），请参考说明文档中'cookie失效的解决办法'一项。");
						return false;
					}
					if (!!doc1_jq.find(".original-image")[0]) { //如果是单图
						imgUrlList[imgNum] = doc1_jq.find(".original-image").attr("data-src");
						imgTitle.push(doc1_jq.find(".work-info .title").text());
						addTagToArray();
						output();
					} else if (!!doc1_jq.find(".works_display")[0]) { //单图以外的情况
						if (!!$(doc1).find(".full-screen._ui-tooltip")[0]) { //如果是动图 DOMParser之后无法解析（找到）canvas标签，不然判断更简单
							imgUrlList[imgNum] = doc1_jq.find("#wrapper script").eq(0).text().split("\"src\":\"")[2].split("\",\"mime_type")[0].replace(/\\/g, ""); //DOMParser之后js不会执行，所以无法用p站自己的动图变量来获取动图网址了
							imgTitle.push(doc1_jq.find(".work-info .title").text());
							addTagToArray();
							output();
						} else {
							if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=manga") > -1) { //如果有mode=manga，是多图
								_allmanga.push(doc1_jq.find("link[rel='alternate']")[0].href.split("illust_id=")[1].split("&")[0]); //将多图作品的id追加到标识多图的数组里
								nowimgTitle = doc1_jq.find(".work-info .title").text();
								var pNum = Number(doc1_jq.find("ul.meta li").eq(1).text().split(" ")[1].split("P")[0]); //P数
								var thumbHref = doc1_jq.find(".works_display img").attr("src"); //缩略图url
								var imgUrlSplit = thumbHref.replace("600x600", "1200x1200").split("p0");
								for (var i = pNum - 1; i >= 0; i--) {
									imgUrlList[imgNum] = imgUrlSplit[0] + "p" + i + imgUrlSplit[1];
									imgTitle.push(nowimgTitle);
									addTagToArray();
									output();
								};
							} else if (doc1_jq.find(".works_display a").eq(0).attr("href").indexOf("mode=big") > -1) { //对于mode=big的情况，不再进行跳转
								var trueurl = doc1_jq.find(".bookmark_modal_thumbnail").attr("data-src");
								trueurl = trueurl.replace("c/150x150/img-master", "img-original");
								trueurl = trueurl.replace("_master1200", "");
								imgUrlList[imgNum] = trueurl;
								imgTitle.push(doc1_jq.find(".work-info .title").text());
								addTagToArray();
								output();
							}
						}
					}
					if (allPageUrl.length > 0) { //如果存在下一个作品，则
						ajaxfordoc1(allPageUrl[0]);
					} else { //没有剩余作品
						ajax1No++;
						if (ajax1No === ajax1Bingfa) { //如果所有请求都执行完毕
							ok(loopNumIn);
							ajax1No = 0; //复位
						}
					}
				},
				statusCode: { //如果发生了错误则跳过该url
					0: function() {
						//ERR_CONNECTION_RESET 或者遇到跨域问题时
						ajaxfordoc1(allPageUrl[0]);
						console.log('请求的url不可访问');
					},
					403: function() {
						//403错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('无权访问请求的ur');
					},
					404: function() {
						//404错误
						ajaxfordoc1(allPageUrl[0]);
						console.log('未找到该页面');
					}
				}
			});
		}

		//获取网址成功立即下载
		function ok(loopNumIn) {
			$(outputInfo).html($(outputInfo).html() + "<br>获取完毕，现在开始下载<br>");
			if (imgUrlList.length == 0) {
				$(outputInfo).html($(outputInfo).html() + ("<br>没有作品需要下载，本次任务已完成。<br><br>"));
				imgNum = 0;
				allowWork = true;
				alert("没有作品需要下载，本次任务已完成。");
			};
			var nowHtml = $(outputInfo).html();
			var reg = new RegExp(/'|#|&|\\|\/|:|\?|"|>|<|\*|\|/g); //将以下字符串替换为空格： ' # \ / : ? " < > * | 其中'会导致php创建文件时路径异常而失败，#则是不能用在url里，否则从#开始往后的字符都不会被当做是参数。剩下几个是windows中不允许做文件名的字符。至此困扰我好久的偶尔漏下图片的问题终于有眉目了
			var reg2 = new RegExp(/\n/g); //替换掉专辑名称中的换行符
			var artname = "专辑" + window.location.href.split("/")[window.location.href.split("/").length - 1] + "_" + $(".am__title ").text().replace(reg, "").replace(reg2, " "); //类似于：专辑1277_【被美丽的翅膀所吸引】蝴蝶特辑
			var loopNum = loopNumIn;
			var length = imgUrlList.length; //这个变量用来对比验证批次请求是否全部完成
			var length2 = length; //这个变量用在每张图片下载成功之后，然后自减1
			var send = 0; //已成功获取的数量的
			var send2 = 0; //已发送的请求数量

			function fenpi(loopNum) {
				if (length2 < loopNum) { //url数量少于设置的请求数则发送url的实际数量
					loopNum = length2;
				};
				for (var i = 0; i < loopNum; i++) {
					var d = imgUrlList[0].split("/img/")[1].split("/"); //分割取出时间和文件名 ["2008", "06", "04", "23", "29", "25", "921663_p0.jpg"]
					var aid = d[6].split("_")[0]; //图片id
					var ismanga = 0;
					if (_allmanga.indexOf(aid) > -1) {
						ismanga = 1;
					}
					$.ajax({
						url: _phpPatch + "?url=" + encodeURI(imgUrlList[0] + "&aid=id" + aid + "&title=" + imgTitle[0].replace(reg, " ") + "&ismanga=" + ismanga + "&year=" + d[0] + "&month=" + d[1] + "&day=" + d[2] + "&h=" + d[3] + "&m=" + d[4] + "&s=" + d[5] + "&filename=" + d[6] + "&artname=" + artname + "&tag=" + tagArray[0].replace(reg, " ") + "&startUrl=" + startUrl),
						type: "get",
						async: true,
						cache: false,
						dataType: "text",
						success: function(data) { //这里是判断成功，而不是失败了。因为专辑的域名www.pixivision.net加在了php的header头里，所以可以返回成功信息
							if (data !== "" && data.indexOf("fopen") > -1) { //php文件在成功时返回值是""。
								var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
								$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Warning：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
								nowHtml = $(outputInfo).html();
							}
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								imgNum = 0;
								allowWork = true;
								alert("下载完毕！");
							};
						},
						error: function() {
							var nowId = this.url.split("&aid=id")[1].split("&title=")[0];
							$(outputInfo).html($(outputInfo).html() + "<br><span style='color:#f00'>Error：id为" + "<a href='https://www.pixiv.net/member_illust.php?mode=medium&illust_id=" + nowId + "' target='_blank'>" + nowId + "</a>" + "的作品下载失败，点击id可以打开该作品页面。</span><br>");
							nowHtml = $(outputInfo).html();
							send++;
							$(outputInfo).html(nowHtml + "已获取" + send + "张图片，还剩" + (length2 - 1) + "张");
							length2--;
							if (send2 < length) {
								fenpi(1);
							}
							if (length2 == 0) {
								$(outputInfo).html($(outputInfo).html() + ("<br>下载完毕！<br><br>"));
								imgNum = 0;
								allowWork = true;
								alert("下载完毕！");
							};
						}
					});
					send2++;
					imgUrlList.shift();
					imgTitle.shift();
					tagArray.shift();
				}
			}

			fenpi(loopNum);
		}

		var outputInfo = document.createElement("div");
		outputInfo.id = "outputInfo";
		outputInfo.style.cssText = "background: #fff;padding: 10px;font-size: 14px;margin:6px auto;width:950px;";

		(function() {
			var downloadBotton = document.createElement("div");
			document.body.appendChild(downloadBotton);
			$(downloadBotton).text("下载该专辑作品");
			$(downloadBotton).attr("title", "下载该专辑作品")
			downloadBotton.style.cssText = "background: #00A514;border-radius: 3px;color: #fff;text-align: center;padding: 10px 5px;position: fixed;top: 335px;right: 0;z-index: 9999;cursor: pointer;";
			downloadBotton.addEventListener("click", function() {
				$(".logo-area h1").hide();
				document.body.insertBefore(outputInfo, $(".body-container")[0]);
				startGet();
			}, false);
		})();
	}()
}
*/