<?php
    set_time_limit(0);  //防止下载超时
    header("Access-Control-Allow-Origin:*");
    function pixiv_img($url)
    {
        $refer = "http://www.pixiv.net/";
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
        curl_setopt($ch, CURLOPT_REFERER, $refer);
        $cexecute = curl_exec($ch);
        curl_close($ch);
        if ($cexecute) {
            return $cexecute;
        }else{
            return false;
        }
    }
    function pixiv_zip($url)
    {
        $opt=array('http'=>array('header'=>"Referer: http://www.pixiv.net/"));
        $context=stream_context_create($opt);
        $zip=file_get_contents( $url,false, $context);
        if($zip){
            return $zip;
        }else{
            return false;
        }
    }
    function http_status($url) {
        $refer = "http://www.pixiv.net/";
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, 1);
        curl_setopt($ch, CURLOPT_NOBODY, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 5);
        curl_setopt($ch, CURLOPT_REFERER, $refer);
        curl_exec($ch);
        $status = (int)curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);
        if ($status == 404||$status == 403) {
            return 1;
        }
    }
    function gb2312_substr($str, $limit) {
        $restr ='';
        for($i=0;$i< $limit-3;$i++) {
            $restr .= ord($str[$i])>127 ? $str[$i].$str[++$i] : $str[$i];
        }
        return $restr;
    }
?>
<?php
    $systemLang=$_SERVER["HTTP_ACCEPT_LANGUAGE"];   //用浏览器语言设置判断系统语言 中国的语言是zh-CN，台湾是zh-TW。其实有的繁体系统LANGUAGE里同时有zh-tw和zh-cn。
    if (preg_match("/zh-tw/i", $systemLang)){
        $isNotZHCN=true;    //非简体中文系统，其文件夹和文件名不使用中文和日文
    }else{
        $isNotZHCN=false;
    }

    $url=$_GET['url'];
    // $filename=iconv('utf-8', 'gbk//ignore',$_GET['aid']."_".$_GET['title']."_".$_GET['year'].$_GET['month'].$_GET['day']."-".$_GET['h'].$_GET['m'].$_GET['s']."_".$_GET['filename']);
    $filename=iconv('utf-8', 'gbk//ignore',$_GET['filename']);
    $artname=str_replace("\\", "\\\\",iconv('utf-8', 'gbk//ignore', $_GET['artname']));   //处理可能存在的汉字字符，转换成gbk编码。另外有些字像"黒"的gbk编码是FC5C，5C在ASCII里是特殊符号"\"，需要处理
    if ($isNotZHCN&&strstr($artname, "id")!==false) {   //如果是非简中系统，则去掉【画师文件夹】(如'id6327914_LF')里的下划线和画师名。由于其他模式里包含的日文是不能去掉的重要元素，所以其他模式暂不处理
        $pos = strpos($artname, "_");
        $artname=substr($artname,0,$pos);
    }

    $rootdir=dirname(__FILE__)."/pixivimg/"; //存放所有图片的文件夹。这里使用了本php文件所在的路径，如果要修改为其他文件夹，请将$rootdir设置为完整路径，如 $rootdir="F:/pictures/pixivimg/";
    $rootdir=str_replace("\\", "/", iconv('utf-8', 'gbk//ignore',$rootdir));    //支持中文路径
    if(!is_dir($rootdir)){  //如果根文件夹不存在则创建
        mkdir($rootdir,0777,true);  //第三个参数设置为true表示允许创建多级文件夹
    }
    if(!is_dir($rootdir.$artname)){         //如果传递了画师名，则检查是否有画师的文件夹。如果没有
        mkdir(str_replace("\\", "\\\\",$rootdir.$artname),0777);
    }
    $artname=$artname."/";          //文件夹已存在的话给画师名加上路径符号
    $makeHtmlPath=$rootdir.$artname;

    if($_GET['ismanga']==="1"){         //如果这是多p作品，则以id建立文件夹单独存放
        if(!is_dir($rootdir.$artname.$_GET['aid'])){
            mkdir($rootdir.$artname.$_GET['aid'],0777);
        }
        $artname=$artname.$_GET['aid']."/";
        if(http_status($url)===1){ //如果这个url是403或者404
            $info = pathinfo($filename);//获取文件的扩展名
            $extname=$info['extension'];//将扩展名变换一下 因为为了效率，js并没有爬取多图作品的详情页，所以后缀是jpg还是png完全不知道，先全部定义成某一个格式。这个格式如果是错的，就替换成正确的。因此需要判断一下这个网址。
            if($extname==="jpg"){
                $url=str_replace(".jpg", ".png", $url); //尝试把图片的jpg后缀改为png重试
                $filename=str_replace(".jpg", ".png", $filename);
            }elseif($extname==="png"){
                $url=str_replace(".png", ".jpg", $url); //尝试把图片的png后缀改为jpg重试
                $filename=str_replace(".png", ".jpg", $filename);
            }
        };
    }

    if (!$isNotZHCN) {  //如果是简中系统，则把tag插入到文件名里
        $tag=str_replace("\\", "\\\\",iconv('utf-8', 'gbk//ignore', $_GET['tag']));
        $filenameLength=strlen($filename);  //计算文件名的长度
        $tagLength=256-strlen($rootdir.$artname)-$filenameLength-6;   //计算留给tag的长度有多少 最后的数字是下面将tag插入文件名时的拼接字符串的长度，以及容错（原本我最后写的是4，但极少数情况下偶尔还会超长
        if (strlen($tag)>$tagLength) {  //如果tag长度超出则截取
            $tag=gb2312_substr($tag,$tagLength);
        }
        $filename=substr($filename,0,$filenameLength-4)."-".$tag.substr($filename,$filenameLength-4,$filenameLength);// 将tag插入到文件后缀名之前
    }

    $fullName=$rootdir.$artname.$filename;

    if (file_exists($fullName)&&filesize($fullName)>1000) { //如果文件已存在且大于指定大小，则认为这是一个正常的文件，已经下载过了，就跳过本次下载。
        exit;
    };

    if(strpos($_GET['filename'],".zip")){    //区分下载zip和图片
        $img = pixiv_zip($url);
    }else{
        $img = pixiv_img($url);
    }

    $file = fopen($fullName,"w");//打开文件准备写入
    fwrite($file,$img);//写入
    fclose($file);//关闭
    echo "ok";

     if(!empty($_GET['startUrl'])){        //建立任务网址的快捷方式
        $startUrl=str_replace("_and_", "&", $_GET['startUrl']);
        $makeHtml = $makeHtmlPath.'.index.html';    //快捷方式路径和名称
        if (!file_exists($makeHtml)){
            $word = "<script type='text/javascript'>window.location.href='".$startUrl."'</script>";
            file_put_contents($makeHtml, $word);
        }
     }
?>